// modules are defined as an array
// [ module function, map of requires ]
//
// map of requires is short require name -> numeric require
//
// anything defined in a previous bundle is accessed via the
// orig method which is the require for previous bundles

(function(modules, cache, entry, mainEntry, parcelRequireName, globalName) {
  /* eslint-disable no-undef */
  var globalObject =
    typeof globalThis !== 'undefined'
      ? globalThis
      : typeof self !== 'undefined'
      ? self
      : typeof window !== 'undefined'
      ? window
      : typeof global !== 'undefined'
      ? global
      : {};
  /* eslint-enable no-undef */

  // Save the require from previous bundle to this closure if any
  var previousRequire =
    typeof globalObject[parcelRequireName] === 'function' &&
    globalObject[parcelRequireName];
  // Do not use `require` to prevent Webpack from trying to bundle this call
  var nodeRequire =
    typeof module !== 'undefined' &&
    typeof module.require === 'function' &&
    module.require.bind(module);

  function newRequire(name, jumped) {
    if (!cache[name]) {
      if (!modules[name]) {
        // if we cannot find the module within our internal map or
        // cache jump to the current global require ie. the last bundle
        // that was added to the page.
        var currentRequire =
          typeof globalObject[parcelRequireName] === 'function' &&
          globalObject[parcelRequireName];
        if (!jumped && currentRequire) {
          return currentRequire(name, true);
        }

        // If there are other bundles on this page the require from the
        // previous one is saved to 'previousRequire'. Repeat this as
        // many times as there are bundles until the module is found or
        // we exhaust the require chain.
        if (previousRequire) {
          return previousRequire(name, true);
        }

        // Try the node require function if it exists.
        if (nodeRequire && typeof name === 'string') {
          return nodeRequire(name);
        }

        var err = new Error("Cannot find module '" + name + "'");
        err.code = 'MODULE_NOT_FOUND';
        throw err;
      }

      localRequire.resolve = resolve;
      localRequire.cache = {};

      var module = (cache[name] = new newRequire.Module(name));

      modules[name][0].call(
        module.exports,
        localRequire,
        module,
        module.exports,
        this
      );
    }

    return cache[name].exports;

    function localRequire(x) {
      return newRequire(localRequire.resolve(x));
    }

    function resolve(x) {
      return modules[name][1][x] || x;
    }
  }

  function Module(moduleName) {
    this.id = moduleName;
    this.bundle = newRequire;
    this.exports = {};
  }

  newRequire.isParcelRequire = true;
  newRequire.Module = Module;
  newRequire.modules = modules;
  newRequire.cache = cache;
  newRequire.parent = previousRequire;
  newRequire.register = function(id, exports) {
    modules[id] = [
      function(require, module) {
        module.exports = exports;
      },
      {},
    ];
  };

  Object.defineProperty(newRequire, 'root', {
    get: function() {
      return globalObject[parcelRequireName];
    },
  });

  globalObject[parcelRequireName] = newRequire;

  for (var i = 0; i < entry.length; i++) {
    newRequire(entry[i]);
  }

  if (mainEntry) {
    // Expose entry point to Node, AMD or browser globals
    // Based on https://github.com/ForbesLindesay/umd/blob/master/template.js
    var mainExports = newRequire(mainEntry);

    // CommonJS
    if (typeof exports === 'object' && typeof module !== 'undefined') {
      module.exports = mainExports;

      // RequireJS
    } else if (typeof define === 'function' && define.amd) {
      define(function() {
        return mainExports;
      });

      // <script>
    } else if (globalName) {
      this[globalName] = mainExports;
    }
  }
})({"4RFDN":[function(require,module,exports) {
var HMR_HOST = null;var HMR_PORT = 1234;var HMR_ENV_HASH = "d751713988987e9331980363e24189ce";module.bundle.HMR_BUNDLE_ID = "1b29d39329fd0a12121be525c35b9498";/* global HMR_HOST, HMR_PORT, HMR_ENV_HASH */

var OVERLAY_ID = '__parcel__error__overlay__';

var OldModule = module.bundle.Module;

function Module(moduleName) {
  OldModule.call(this, moduleName);
  this.hot = {
    data: module.bundle.hotData,
    _acceptCallbacks: [],
    _disposeCallbacks: [],
    accept: function(fn) {
      this._acceptCallbacks.push(fn || function() {});
    },
    dispose: function(fn) {
      this._disposeCallbacks.push(fn);
    },
  };

  module.bundle.hotData = null;
}

module.bundle.Module = Module;
var checkedAssets, assetsToAccept, acceptedAssets;

function getHostname() {
  return (
    HMR_HOST ||
    (location.protocol.indexOf('http') === 0 ? location.hostname : 'localhost')
  );
}

function getPort() {
  return HMR_PORT || location.port;
}

// eslint-disable-next-line no-redeclare
var parent = module.bundle.parent;
if ((!parent || !parent.isParcelRequire) && typeof WebSocket !== 'undefined') {
  var hostname = getHostname();
  var port = getPort();
  var protocol = location.protocol === 'https:' ? 'wss' : 'ws';
  var ws = new WebSocket(
    protocol + '://' + hostname + (port ? ':' + port : '') + '/',
  );
  ws.onmessage = function(event) {
    checkedAssets = {};
    assetsToAccept = [];
    acceptedAssets = {};

    var data = JSON.parse(event.data);

    if (data.type === 'update') {
      // Remove error overlay if there is one
      removeErrorOverlay();

      let assets = data.assets.filter(asset => asset.envHash === HMR_ENV_HASH);

      // Handle HMR Update
      var handled = false;
      assets.forEach(asset => {
        var didAccept =
          asset.type === 'css' || hmrAcceptCheck(module.bundle.root, asset.id);
        if (didAccept) {
          handled = true;
        }
      });

      if (handled) {
        console.clear();

        assets.forEach(function(asset) {
          hmrApply(module.bundle.root, asset);
        });

        for (var i = 0; i < assetsToAccept.length; i++) {
          var id = assetsToAccept[i][1];
          if (!acceptedAssets[id]) {
            hmrAcceptRun(assetsToAccept[i][0], id);
          }
        }
      } else {
        window.location.reload();
      }
    }

    if (data.type === 'error') {
      // Log parcel errors to console
      for (let ansiDiagnostic of data.diagnostics.ansi) {
        let stack = ansiDiagnostic.codeframe
          ? ansiDiagnostic.codeframe
          : ansiDiagnostic.stack;

        console.error(
          '🚨 [parcel]: ' +
            ansiDiagnostic.message +
            '\n' +
            stack +
            '\n\n' +
            ansiDiagnostic.hints.join('\n'),
        );
      }

      // Render the fancy html overlay
      removeErrorOverlay();
      var overlay = createErrorOverlay(data.diagnostics.html);
      document.body.appendChild(overlay);
    }
  };
  ws.onerror = function(e) {
    console.error(e.message);
  };
  ws.onclose = function(e) {
    console.warn('[parcel] 🚨 Connection to the HMR server was lost');
  };
}

function removeErrorOverlay() {
  var overlay = document.getElementById(OVERLAY_ID);
  if (overlay) {
    overlay.remove();
    console.log('[parcel] ✨ Error resolved');
  }
}

function createErrorOverlay(diagnostics) {
  var overlay = document.createElement('div');
  overlay.id = OVERLAY_ID;

  let errorHTML =
    '<div style="background: black; opacity: 0.85; font-size: 16px; color: white; position: fixed; height: 100%; width: 100%; top: 0px; left: 0px; padding: 30px; font-family: Menlo, Consolas, monospace; z-index: 9999;">';

  for (let diagnostic of diagnostics) {
    let stack = diagnostic.codeframe ? diagnostic.codeframe : diagnostic.stack;

    errorHTML += `
      <div>
        <div style="font-size: 18px; font-weight: bold; margin-top: 20px;">
          🚨 ${diagnostic.message}
        </div>
        <pre>
          ${stack}
        </pre>
        <div>
          ${diagnostic.hints.map(hint => '<div>' + hint + '</div>').join('')}
        </div>
      </div>
    `;
  }

  errorHTML += '</div>';

  overlay.innerHTML = errorHTML;

  return overlay;
}

function getParents(bundle, id) {
  var modules = bundle.modules;
  if (!modules) {
    return [];
  }

  var parents = [];
  var k, d, dep;

  for (k in modules) {
    for (d in modules[k][1]) {
      dep = modules[k][1][d];

      if (dep === id || (Array.isArray(dep) && dep[dep.length - 1] === id)) {
        parents.push([bundle, k]);
      }
    }
  }

  if (bundle.parent) {
    parents = parents.concat(getParents(bundle.parent, id));
  }

  return parents;
}

function updateLink(link) {
  var newLink = link.cloneNode();
  newLink.onload = function() {
    if (link.parentNode !== null) {
      link.parentNode.removeChild(link);
    }
  };
  newLink.setAttribute(
    'href',
    link.getAttribute('href').split('?')[0] + '?' + Date.now(),
  );
  link.parentNode.insertBefore(newLink, link.nextSibling);
}

var cssTimeout = null;
function reloadCSS() {
  if (cssTimeout) {
    return;
  }

  cssTimeout = setTimeout(function() {
    var links = document.querySelectorAll('link[rel="stylesheet"]');
    for (var i = 0; i < links.length; i++) {
      var href = links[i].getAttribute('href');
      var hostname = getHostname();
      var servedFromHMRServer =
        hostname === 'localhost'
          ? new RegExp(
              '^(https?:\\/\\/(0.0.0.0|127.0.0.1)|localhost):' + getPort(),
            ).test(href)
          : href.indexOf(hostname + ':' + getPort());
      var absolute =
        /^https?:\/\//i.test(href) &&
        href.indexOf(window.location.origin) !== 0 &&
        !servedFromHMRServer;
      if (!absolute) {
        updateLink(links[i]);
      }
    }

    cssTimeout = null;
  }, 50);
}

function hmrApply(bundle, asset) {
  var modules = bundle.modules;
  if (!modules) {
    return;
  }

  if (modules[asset.id] || !bundle.parent) {
    if (asset.type === 'css') {
      reloadCSS();
    } else {
      var fn = new Function('require', 'module', 'exports', asset.output);
      modules[asset.id] = [fn, asset.depsByBundle[bundle.HMR_BUNDLE_ID]];
    }
  } else if (bundle.parent) {
    hmrApply(bundle.parent, asset);
  }
}

function hmrAcceptCheck(bundle, id) {
  var modules = bundle.modules;

  if (!modules) {
    return;
  }

  if (!modules[id] && bundle.parent) {
    return hmrAcceptCheck(bundle.parent, id);
  }

  if (checkedAssets[id]) {
    return;
  }

  checkedAssets[id] = true;

  var cached = bundle.cache[id];

  assetsToAccept.push([bundle, id]);

  if (cached && cached.hot && cached.hot._acceptCallbacks.length) {
    return true;
  }

  return getParents(module.bundle.root, id).some(function(v) {
    return hmrAcceptCheck(v[0], v[1]);
  });
}

function hmrAcceptRun(bundle, id) {
  var cached = bundle.cache[id];
  bundle.hotData = {};
  if (cached && cached.hot) {
    cached.hot.data = bundle.hotData;
  }

  if (cached && cached.hot && cached.hot._disposeCallbacks.length) {
    cached.hot._disposeCallbacks.forEach(function(cb) {
      cb(bundle.hotData);
    });
  }

  delete bundle.cache[id];
  bundle(id);

  cached = bundle.cache[id];
  if (cached && cached.hot && cached.hot._acceptCallbacks.length) {
    cached.hot._acceptCallbacks.forEach(function(cb) {
      var assetsToAlsoAccept = cb(function() {
        return getParents(module.bundle.root, id);
      });
      if (assetsToAlsoAccept && assetsToAccept.length) {
        assetsToAccept.push.apply(assetsToAccept, assetsToAlsoAccept);
      }
    });
  }
  acceptedAssets[id] = true;
}

},{}],"4PwlW":[function(require,module,exports) {
"use strict";

var _ui = require("../../ui");

var _App = _interopRequireDefault(require("./App"));

require("./index.css");

require("./globalStore");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_ui.Exir.mount(_App.default, document.getElementById('app'));
},{"../../ui":"2Wqnn","./App":"2gqzN","./index.css":"4Bos7","./globalStore":"305r2"}],"2Wqnn":[function(require,module,exports) {
const {
  View,
  createView
} = require("./view");

const {
  h
} = require("./h");

const {
  render
} = require("./render");
/**
 * @type {function(*): View}
 * @alias createView
 */


const createComponent = createView;
/**
 * @type {function(type, props, ...children): View|VNode}
 */

const jsx = h;
/**
 * @param {{attachTo: function(type)}} plugin
 */

const use = function (plugin) {
  plugin.attachTo(View);
};

module.exports = {
  Exir: {
    View,
    createComponent,
    jsx,
    mount: render,
    use
  }
};
},{"./view":"7zuzL","./h":"6vQOL","./render":"7qsDg"}],"7zuzL":[function(require,module,exports) {
require("../core/scope");

const TYPE = require("./type");

const {
  updateView
} = require("./patch");

const {
  debounce
} = require("../core/functions");

const {
  error
} = require("../core/logging");

const {
  randomId,
  normalize,
  sameProps
} = require("./utils");

const {
  createNode
} = require("./vnode");

const {
  warn
} = require("../core/logging");

const {
  deepClone
} = require("../core/collections");

const {
  createText
} = require("./vnode");
/**
 * @param {Object} args.state
 * @param {String} [args.name]
 * @param {Function} args.render
 * @param {Function} args.beforeUpdate
 * @param {Function} args.Updated
 * @param {Function} args.beforeMount
 * @param {Function} args.Mounted
 * @param {Function} args.beforeCreate
 * @param {Function} args.Created
 * @constructor
 */


function View(args = {}) {
  this.$t = TYPE.VIEW;
  args.name = args.name || 'View' + '::' + randomId();
  this.$name = args.name;
  this.$proto = Object.freeze(args);
  let props = Object.getOwnPropertyNames(args);

  for (let i = 0; i < props.length; i++) {
    const prop = props[i];

    if (args[prop] instanceof Function) {
      this[prop] = args[prop].bind(this);
    } else {
      this[prop] = deepClone(args[prop]);
    }
  } // this.$instanceId = Symbol('view')
  // this.$instanceId = randomId();


  this.props = this.props || {};
  this.state = this.state || {}; // this.$children = [];

  if (!this.render) {
    warn("View has no render!");

    this.render = () => "";
  }

  Object.defineProperty(this, '$elements', {
    get() {
      return this.$nodes.flatMap(n => {
        if (n === undefined || n === null) return [];
        if (n.$isView) return n.$elements;
        return n.element;
      });
    }

  });
}

Object.defineProperty(View.prototype, '$parent', {
  value: undefined,
  configurable: false,
  writable: true,
  enumerable: false
});
View.prototype.$isView = true;

View.prototype.$clone = function () {
  return new View({ ...this.$proto
  });
};

View.prototype.$updateWith = function (props, children) {
  if (props.key) {
    this.$key = props.key; // delete props.key
  }

  this.props = { ...this.props,
    ...props
  };
  this.$children = normalize(children, {
    createText
  });
  return this;
};

View.prototype.$renderNodes = function () {
  return normalize(this.render({
    props: this.props,
    state: this.state
  }), {
    createText,
    parent: this,
    empty: [createNode('slot', {
      style: 'display: none'
    })]
  });
};

View.prototype.$renderAndSetNodes = function () {
  if (this.beforeCreate) try {
    this.beforeCreate();
  } catch (e) {
    setTimeout(error('(' + this.$name + ').beforeCreate()', e));
  }
  this.$nodes = this.$renderNodes();
  if (this.Created) try {
    this.Created();
  } catch (e) {
    setTimeout(error('(' + this.$name + ').Created()', e));
  }
  return this;
};

View.prototype.$destroy = function (getAnchor) {
  if (this.beforeDestroy) {
    try {
      this.beforeDestroy();
    } catch (e) {
      setTimeout(error('(' + this.$name + ').beforeDestroy()', e));
    }
  } // first real dom element


  let firstEl = undefined;

  for (let i = 0; i < this.$nodes.length; i++) {
    let n = this.$nodes[i];

    if (n.element) {
      if (!firstEl) firstEl = n.element;else n.element.remove();
    } else {
      firstEl = firstEl || n.$destroy();
    }
  }

  if (getAnchor) return firstEl;else firstEl && firstEl.remove();
};

View.prototype.$clean = function () {
  this.$nodes = undefined;
  this.state = undefined;
  this.props = undefined;
}; //


View.prototype.$update = debounce(function () {
  updateView(this);
}, 20); //
// View.prototype.$update = function () {
//     updateView(this);
// };

View.prototype.setState = function (fn) {
  let state = this.state;
  fn.call(this, state); // this.$isDirty = !sameProps(this.state, state);

  this.$isDirty = true; // console.log('setState', this)

  this.$update();
}; // View.prototype.$update = debounce(function () {
//     this.$isDirty = true;
//     // console.trace('$update', this.$name, this.props)
//     dispatchTask(() => patchView(this, this.props, this.$children), this.$instanceId)
// }, 5)


function isViewClass(cls) {
  return Object.prototype.isPrototypeOf.call(View, cls);
}

function getViewInstance(view, newArgs) {
  if (isViewClass(view)) {
    return new view(newArgs);
  }

  if (view instanceof View) {
    return view;
  }

  if (view === View) {
    return new View(newArgs);
  }

  throw TypeError("Cannot get view instance of " + view);
}

function renderView(view, props, children) {
  // // if (!view.props) view.props = {};
  // if (props) {
  //     concat(view.props, props, true);
  // }
  // if (children) {
  children = normalize(children || [], {
    createText
  });
  view.$children = children; // }

  view.$updateWith(props, children);
  view.$renderAndSetNodes();
  return view;
}
/**
 * @typedef View
 * @class
 * @member {Function} beforeCreate
 * @member {Function} Created
 * @member {Function} beforeMount
 * @member {Function} Mounted
 * @member {Function} beforeUpdate
 * @member {Function} Updated
 * @member {Function} beforeDestroy
 */


module.exports = {
  View,
  isViewClass,
  getViewInstance,
  createView: function (args) {
    return new View(args);
  },
  renderView
};
},{"../core/scope":"65tBD","./type":"31kdc","./patch":"2vNOU","../core/functions":"1xAXG","../core/logging":"2wPER","./utils":"4gsj0","./vnode":"5nsjA","../core/collections":"ZJYAj"}],"65tBD":[function(require,module,exports) {
var global = arguments[3];

/**
 * Merges an object with global namespace
 * @private
 * @param {Object} obj
 */
function setGlobal(obj) {
  for (let key of Object.keys(obj)) {
    global[key] = obj[key];
  }
}
/**
 * Code generator for prototype modification, used in polyfills
 */


class Extension {
  /**
   * @constructor
   * @param {any[]} types - Array of prototypes
   */
  constructor(types) {
    this.types = types;
    this.types = [];
    /** Generated code */

    this.pcode = "\n";
  }
  /**
   * Defines a new function for given prototypes
   *
   * @param {Function} namedFunc A named function
   * @return {string}
   */


  define(namedFunc) {
    if (!namedFunc.name) {
      let err = `Function must have a name [Extension.define(f)]\n<<${namedFunc}>>`;
      console.error(err);
      return `\n/**\n *${err}\n */`;
    }

    let code = "\n";

    for (let p of this.types) {
      if (p !== undefined) code += `${p.name || p}.prototype.${namedFunc.name} = `;
    }

    code += namedFunc.toString() + ";\n";
    this.pcode += code;
    return code;
  }

  polyfill(namedFunc) {
    if (!namedFunc.name) {
      let err = `Extension function must have a name:\n<<${namedFunc}>>`;
      console.error(err);
      return `\n/**\n *${err}\n */`;
    }

    let code = "\n";

    for (let p of this.types) {
      code += `if (${p.name || p}.prototype.${namedFunc.name} === undefined) ${p.name || p}.prototype.${namedFunc.name} = ${namedFunc.toString()};\n`;
    }

    this.pcode += code;
  }

}

function isBrowser() {
  return global.window !== undefined && global.document !== undefined && global.navigator !== undefined;
}

if (!isBrowser()) {
  // -------------
  global.HTMLElement = !global.HTMLElement ? function HTMLElement() {} : global.HTMLElement;
  global.Element = !global.Element ? function Element() {} : global.Element;
  global.Node = !global.Node ? function Node() {} : global.Node;
  global.HTMLCollection = !global.HTMLCollection ? function HTMLCollection() {} : global.HTMLCollection;
  global.NodeList = !global.NodeList ? function NodeList() {} : global.NodeList; // -------------
}

module.exports = {
  setGlobal,
  Extension,
  isBrowser
};
},{}],"31kdc":[function(require,module,exports) {
/**
 * @name TYPE
 */
module.exports = {
  FRAG: -1,
  TEXT: 0,
  NODE: 1,
  VIEW: 2
};
},{}],"2vNOU":[function(require,module,exports) {
// const {randomId} = require("./utils");
const {
  dispatchTask,
  scheduler
} = require("./scheduler");

const {
  createDom,
  createNodeDom,
  createViewDom,
  createChildrenDom
} = require("./render");

const {
  error
} = require("../core/logging");

const {
  patchAttrs,
  patchEvents
} = require("./patch-element");

const {
  createText,
  createNode
} = require("./vnode");

const {
  normalize,
  sameProps
} = require("./utils");

function updateView(view) {
  // view.$isDirty = true;
  dispatchTask(() => {
    patchView(view, view.props, view.$children); // view.$isDirty = false;
  }, view);
}

function patchView(view, props, children) {
  if (view.shouldUpdate) {
    try {
      if (!view.shouldUpdate.call(view, {
        oldProps: view.props,
        newProps: props
      })) return;
    } catch (e) {
      setTimeout(error('(' + view.$name + ').shouldUpdate', e), 0);
    }
  } else {
    if (!view.$isDirty) return;
  }

  if (view.beforeUpdate) {
    try {
      view.beforeUpdate.call(view, props);
    } catch (e) {
      setTimeout(error('(' + view.$name + ').Updated', e));
    }
  }

  view.$updateWith(props, children);
  const newNodes = view.$renderNodes();
  view.$nodes = patchNodes(newNodes, view.$nodes, view, view.$rootElement);
  view.$isDirty = false;

  if (view.Updated) {
    setTimeout(function () {
      try {
        view.Updated.call(view);
      } catch (e) {
        error('(' + view.$name + ').Updated', e);
      }
    }, 0);
  }
}

function patchNode(_new, _cur, view) {
  if (_new.tag === _cur.tag) {
    _new.element = _cur.element;
    _new.element.__node = _new;
    _cur.element = null;

    if (!sameProps(_cur.props, _new.props)) {
      // console.log('PATCH', _cur.tag)
      patchAttrs(_new.attrs, _cur.attrs, _new.element);
      patchEvents(_new.events, _cur.events, _new.element);
    }

    if (!_new.element) {
      error('Fatal: current node has no element', _cur, _new);
    } // VNode children
    // dispatchTask(()=>patchNodes(_new.children, _cur.children, view, _new.element))


    patchNodes(_new.children, _cur.children, view, _new.element);
  } else {
    // console.log('REPLACE', _cur.tag, _new.tag);
    _new.element = createNodeDom(_new, view);

    _cur.element.replaceWith(_new.element);

    _new.element.__node = _new;
  }
}

function patchText(_new, _cur) {
  if (_new.text !== _cur.text) {
    _cur.element.nodeValue = _new.text;
  }

  _new.element = _cur.element;
  _new.element.__node = _new;
}

function swapElements(_new, _cur) {
  let curSlot = createNodeDom(createNode('div', {
    style: 'display: none'
  }));
  let curNodes = _cur.$isView ? _cur.$elements : [_cur.element];
  let newNodes = _new.$isView ? _new.$elements : [_new.element];
  curNodes[0].insertAdjacentElement('beforeBegin', curSlot);
  newNodes[0].replaceWith(...curNodes);
  curSlot.replaceWith(...newNodes);
}

function patchOrReplaceView(_new, _cur, newNodes, currentNodes, idx, curLen, newLen, parentView, rootElement) {
  let keysMatch = false;

  if (_new.props.key !== undefined) {
    let prev = -1;

    for (let i = idx; i < curLen; i++) {
      if (currentNodes[i].props.key === _new.props.key) {
        prev = i;
        keysMatch = true;
        break;
      }
    }

    if (prev > idx) {
      // _cur === currentNodes[idx]
      // if ((newLen<curLen && prev > curLen))
      swapElements(currentNodes[prev], currentNodes[idx]); // set current as prev

      currentNodes[idx] = currentNodes[prev]; // set prev as _cur

      currentNodes[prev] = _cur;
      _cur = currentNodes[idx];
    }
  }

  if (_cur.$name === _new.$name && keysMatch) {
    patchView(_cur, _new.props, _new.$children);
    _cur.$parent = _new.$parent;
    _new.$parent = undefined;
    newNodes[idx] = _cur;
  } else {
    // console.log(idx, _cur, _new)
    let anchor = _cur.$destroy(true);

    if (_new.$isView) {
      let el = createViewDom(_new, rootElement);
      Element.prototype.replaceWith.apply(anchor, el);
    } else {
      let el = createNodeDom(_new, parentView);
      anchor.replaceWith(el);
      _new.element = el;
      _new.element.__node = _new;
    }
  }
}

function replaceNodes(_new, _cur, parentView, rootElement) {
  const el = createDom(_new, parentView, rootElement);
  let anchor = undefined;

  if (_cur.isNode || _cur.isText) {
    anchor = _cur.element;
  } else {
    anchor = _cur.$destroy(true);
  }

  if (anchor) {
    Element.prototype.replaceWith.apply(anchor, el instanceof Array ? el : [el]);
    _new.element = el;
    _new.element.__node = _new;
  } else {
    console.error('Empty anchor', _cur);
  }
}

function patchNodes(newNodes, currentNodes, parentView, rootElement) {
  if (!rootElement) throw Error('patchNodes: rootElement is not defined');
  let newLen = newNodes.length;
  let curLen = currentNodes.length;
  let added = newLen > curLen;
  let len = added ? curLen : newLen;
  let idx = 0;

  for (; idx < len; idx++) {
    const _cur = currentNodes[idx];
    const _new = newNodes[idx];

    if (_cur.$t === _new.$t) {
      if (_cur.isNode) {
        patchNode(_new, _cur, parentView);
        continue;
      }

      if (_cur.isText) {
        patchText(_new, _cur);
        continue;
      }

      patchOrReplaceView(_new, _cur, newNodes, currentNodes, idx, curLen, newLen, parentView, rootElement);
    } else {
      replaceNodes(_new, _cur, parentView, rootElement);
    }
  }

  if (added) {
    let elements = createChildrenDom(newNodes.slice(idx), parentView, rootElement);
    HTMLElement.prototype.append.apply(rootElement, elements);
  } else if (curLen > newLen) {
    for (let i = idx; i < curLen; i++) {
      currentNodes[i].$destroy();
    }
  }

  return newNodes;
}

module.exports = {
  patchView,
  updateView
};
},{"./scheduler":"5Dn7i","./render":"7qsDg","../core/logging":"2wPER","./patch-element":"h7hOa","./vnode":"5nsjA","./utils":"4gsj0"}],"5Dn7i":[function(require,module,exports) {
const scheduler = Object.seal({
  queue: [],
  busy: false,
  running: false,
  idle: 0
});

function setFrameInterval(fn, interval) {
  let busy = false;
  const queue = [];

  function runner() {
    requestAnimationFrame(function () {
      if (queue.length > 0) {
        let task = queue.shift();
        let time = Date.now();
        busy = true;
        task();
      }

      let to = interval - (Date.now() - time);
      setTimeout(runner, to);
    });
  }
}

function runner() {
  if (scheduler.queue.length === 0) {
    scheduler.idle++;

    if (scheduler.idle > 3) {
      scheduler.running = false;
      return;
    }

    return;
  }

  scheduler.idle = 0;

  if (!scheduler.busy) {
    let task = scheduler.queue.shift();
    scheduler.busy = true;
    task();
    task = null;
    setTimeout(function () {
      scheduler.busy = false;
    });
  }

  setTimeout(runner, 20);
}

function start() {
  if (!scheduler.running) setTimeout(runner, 1);
}

function dispatchTask(task) {
  if (task) {
    scheduler.queue.push(task);
    start();
  }
}

module.exports = {
  dispatchTask,
  scheduler
};
},{}],"7qsDg":[function(require,module,exports) {
const {
  error
} = require("../core/logging");

const {
  flatMap
} = require("../core/collections");

const {
  createNode
} = require("./vnode");

const {
  normalize,
  setElementProps
} = require("./utils");

const {
  createText
} = require("./vnode");

function createElement(tag, attrs, events, parentView) {
  let el = document.createElement(tag);
  setElementProps(el, attrs, events, parentView);
  return el;
}

function createTextDom(text) {
  return document.createTextNode(text);
}

function createChildrenDom(nodes, parentView, rootElement) {
  return nodes.flatMap(n => createDom(n, parentView, rootElement));
}

function createViewDom(view, rootElement) {
  if (view.beforeMount) {
    try {
      view.beforeMount.call(view);
    } catch (e) {
      setTimeout(error('(' + view.$name + ').beforeMount', e));
    }
  }

  if (!view.$nodes) {
    // view.$updateWith(view.props)
    view.$renderAndSetNodes();
  }

  view.$rootElement = rootElement;
  let elements = view.$nodes.map(ch => ch.$isView ? createViewDom(ch, rootElement) : createNodeDom(ch, view));

  if (view.Mounted) {
    setTimeout(function () {
      try {
        view.Mounted.call(view);
      } catch (e) {
        error('(' + view.$name + ').Mounted', e);
      }
    }, 0);
  }

  view.$isDirty = false;
  return elements;
}

function createNodeDom(node, parentView) {
  if (node.isText) {
    node.element = createTextDom(node.text);
    node.element.__node = node;
    return node.element;
  }

  node.element = createElement(node.tag, node.attrs, node.events, parentView);
  node.element.__node = node;

  if (!node.isEmpty) {
    let el = node.children.map(c => createDom(c, parentView, node.element));
    HTMLElement.prototype.append.apply(node.element, normalize(el, {
      createText,
      parent: this
    }));
  }

  return node.element;
}

function createDom(node, parentView, rootElement) {
  return node.$isView ? createViewDom(node, rootElement) : createNodeDom(node, parentView);
}

function render(view, rootElement) {
  if (!rootElement) throw Error('render(): rootElement is undefined');
  let current = rootElement.__app;

  if (current) {
    console.error('already rendered');
    return;
  }

  view.$rootElement = rootElement;
  rootElement.innerHTML = "";
  let els = createDom(view, view, rootElement);
  if (!(els instanceof Array)) els = [els];
  els = flatMap(els);

  for (let i = 0; i < els.length; i++) {
    Node.prototype.appendChild.call(rootElement, els[i]);
  }

  rootElement.__app = view;
}

module.exports = {
  render,
  createDom,
  createNodeDom,
  createViewDom,
  createTextDom,
  createChildrenDom,
  createElement
};
},{"../core/logging":"2wPER","../core/collections":"ZJYAj","./vnode":"5nsjA","./utils":"4gsj0"}],"2wPER":[function(require,module,exports) {
// const {Enum} = require("./types");

/**
 * @module core/logging
 * @memberOf core
 */

/** @private */
function _logTime() {
  let t = new Date();
  return `${t.getHours()}:${t.getMinutes()}:${t.getSeconds()}:${t.getMilliseconds()}`;
}
/** @private */


function _logTitle(flag) {
  return `[${flag}] [${_logTime()}]`;
}
/** @private */


function _prepareLog(args, lt) {
  args.reverse();
  args.push("display: inline-block; font-weight: bold; color: black", "%c" + lt);
  args.reverse();
}
/**
 * @type {Object}
 */


const LogLevels = {
  TRACE: 0,
  INFO: 1,
  WARN: 2,
  ERROR: 3,
  SILENT: -1
};
/**
 * Log config
 * @type {{LogLevel: *}}
 */

const Config = {
  LogLevel: LogLevels.TRACE
};
/** Set `Config.LogLevel` to TRACE */

function showTrace() {
  Config.LogLevel = LogLevels.TRACE;
}
/** Set `Config.LogLevel` to INFO */


function showInfo() {
  Config.LogLevel = LogLevels.INFO;
}
/** Set `Config.LogLevel` to WARN */


function showWarn() {
  Config.LogLevel = LogLevels.WARN;
}
/** Set `Config.LogLevel` to ERROR */


function showError() {
  Config.LogLevel = LogLevels.ERROR;
}
/** Set `Config.LogLevel` to SILENT */


function silent() {
  Config.LogLevel = LogLevels.SILENT;
}
/** Set Config.LogLevel
 * @param l - LogLevel */


function lvl(l) {
  return Config.LogLevel !== LogLevels.SILENT && Config.LogLevel <= l;
}
/**
 * Log Trace
 * @param {any} args
 */


function trace(...args) {
  if (!lvl(LogLevels.TRACE)) return;
  args.reverse();
  args.push(_logTitle("🔍 TRACE"));
  args.reverse(); // args.push("\n");

  console.trace.apply(this, args);
}
/**
 * Log Info
 * @param {any} args
 */


function info(...args) {
  if (!lvl(LogLevels.INFO)) return;

  _prepareLog(args, _logTitle("🔵 INFO"));

  console.log.apply(this, args);
}
/**
 * Log Warning
 * @param {any} args
 */


function warn(...args) {
  if (!lvl(LogLevels.WARN)) return;

  _prepareLog(args, _logTitle("🚨 WARN"));

  console.warn.apply(this, args);
}
/**
 * Log Error
 * @param {any} args
 */


function error(...args) {
  if (!lvl(LogLevels.ERROR)) return;

  _prepareLog(args, _logTitle("💥 ERROR"));

  console.error.apply(this, args);
}

module.exports = {
  Config,
  LogLevels,
  showTrace,
  showInfo,
  showWarn,
  showError,
  silent,
  trace,
  info,
  warn,
  error
};
},{}],"ZJYAj":[function(require,module,exports) {
var global = arguments[3];

/**
 * @module core/collections
 * @memberOf core
 */
const T = require("./types");

if (!global._X_LOOP_BREAK_) {
  global._X_LOOP_BREAK_ = Symbol("BREAK_LOOP");
  global._X_ANY_ = Symbol("ANY");
  global._X_ALL_ = Symbol("ALL");
}
/**
 * Break from functional loops: forEach, filter, ...
 * @type {symbol}
 */


const BREAK = global._X_LOOP_BREAK_;
/**
 * Match Any: Used as value in predicate object
 * @type {symbol}
 */

const ANY = global._X_ANY_;
const ALL = global._X_ALL_;
const UNSAFE_PROPS = ['__proto__', 'constructor', '__defineGetter__', '__defineSetter__', 'prototype'];
/**
 * Get item by index from multiple source types
 *
 * @param {Array|Object|String|NodeList|HTMLCollection} s - source
 * @param {Number|String} i - item index
 * @returns {any|null|undefined}
 */

function item(s, i) {
  if (!T.isVal(s)) return undefined;
  if (T.isObj(s)) return s[i];
  if (T.isStr(s)) return s[i];
  if (T.isArr(s)) return s[i];else return s.item(i);
}
/**
 * Source contains value or key:value
 *
 * @param {Array|Object|String} src
 * @param {any} value
 * @param {String|undefined} [key]
 * @returns {boolean}
 */


function contains(src, value, key) {
  if (!T.isVal(src)) return false;
  if (!T.isArr(src) && T.isObj(src)) return src[key] === value;
  return src.indexOf(value) >= 0;
}
/**
 * Add item(s) to source
 *
 * @param {Array|{add:Function}} src - source
 * @param {any} v - values
 */


function add(src, ...v) {
  if (T.isArr(src)) {
    forEach(v, vi => src.push(vi));
  } else if (T.isMutableList(src)) {
    src.add(v);
  }
}
/**
 * Remove item(s) from source
 *
 * @param {Array|String} src
 * @param {...any} it
 * @returns {boolean}
 */


function remove(src, ...it) {
  it = flatMap(it);
  let any = false;
  forEach(it, item => {
    let idx = src.indexOf(item);

    if (idx >= 0) {
      any = true;
      src.splice(idx, 1);
    }
  });
  return any;
}
/**
 * Toggles items in source
 *
 * @param {Array} src
 * @param {...any} c
 */


function toggle(src, ...c) {
  if (c.length === 0) return;
  c = flatMap(c);
  let idx = undefined;

  if (c.length === 1) {
    if (!remove(src, c)) {
      add(src, c[0]);
    }
  } else {
    c.push(c[0]);
    let any = false;
    forEach(src, (cl, i) => {
      idx = c.indexOf(cl);

      if (idx >= 0 && c.length > idx + 1) {
        any = true;
        src[i] = c[idx + 1];
      }
    });

    if (!any) {
      src.push(c[0]);
    }
  }
}

function objMatchOne(o, match) {
  let m = Object.keys(match);

  for (let k of m) {
    // if (!T.isObj(o[k])) continue;
    if (match[k] === ANY && o.hasOwnProperty(k)) return true;
    if (match[k] === o[k]) return true;
  }

  return false;
}

function objMatchAll(o, match) {
  let m = Object.keys(match);

  for (let k of m) {
    // if (!T.isObj(o[k])) return false;
    if (match[k] === ANY) continue;
    if (match[k] !== o[k]) return false;
  }

  return true;
}

function predicate(f, def = () => true, inc = true) {
  if (T.isUnd(f)) return def;
  if (T.isFun(f)) return f;else if (f instanceof RegExp) return (v, k, i, s) => !T.isObj(v) ? f.test(v.toString()) : false;else if (T.isObj(f)) {
    if (Object.keys(f).length === 0) return def;
    return inc ? (v, k, i, s) => objMatchOne(v, f) : (v, k, i, s) => objMatchAll(v, f);
  } else return (v, k, i, s) => v === f;
}

function funOrKey(f) {
  if (T.isUnd(f)) return v => v;
  if (T.isFun(f)) return f;

  if (T.isStr(f)) {
    const key = f;

    f = v => v[key];
  }

  throw Error(`Predicate ${f} cannot be of type ${typeof f}`);
}
/**
 * Create empty instance of given source
 *
 * @param {any} src - source object
 * @param {any} def - default value for primitives
 * @returns {any} empty instance of src
 */


function emptyOf(src, def = {}) {
  if (T.isStr(src)) return "";
  if (T.isList(src) || T.isArr(src)) return [];

  if (T.isObj(src)) {
    if (T.isEl(src)) {
      if (src.nodeType === 3 || src.nodeType === 8) {
        return document.createTextNode(src.textContent);
      } else {
        return document.createElement(src.tagName);
      }
    }

    if (src.__proto__) return Object.create(src.__proto__);
    return {};
  }

  return def;
}
/**
 * Type-agnostic concat. !!Mutates target!!
 *
 * @param {Array|String|Object} target
 * @param {Array|String|Object} source
 * @returns {Array|String|Object}
 */


function concat(target, source, override = false) {
  if (T.isStr(target)) {
    return target.concat(source);
  }

  if (T.isArr(target)) {
    return target.concat(source);
  }

  for (let k of Object.keys(source)) {
    if (!target[k] || override) target[k] = source[k];
  }

  return target;
}
/**
 * Polyfill-like for Object.values (uses native method if available)
 *
 * @param {Object} obj
 * @returns {Array|undefined} - array of values
 */


function objectValues(obj) {
  if (Object.values) {
    return Object.values(obj);
  } else {
    return map(obj, v => v);
  }
}
/**
 * Index for loop from "init" to "finish"(included) by "step"
 *
 * @param {Function} func
 * @param {Number} init
 * @param {Number} finish
 * @param {Number} [step]
 */


function forN(func, init = 0, finish = 0, step = init < finish ? 1 : -1) {
  if (step > 0) {
    for (; init <= finish; init += step) {
      func(init);
    }
  }

  for (; init >= finish; init += step) {
    func(init);
  }
}
/**
 * forEach(left) with limited range
 *
 * @param {Array|Object|NodeList|HTMLCollection} src
 * @param {Function} func
 * @param {Number} [start]
 * @param {Number?} [end]
 * @returns {*|number}
 */


function forEachRange(src, func, start = 0, end) {
  if (!T.isArr(src) || !T.isStr(src)) {
    let keys = Object.keys(src);
    end = end || keys.length - 1;

    for (let i = start; i <= end; i++) {
      let r = func(src[keys[i]], keys[i], i, src);
      if (r === BREAK) return i;
    }

    return end;
  }

  end = end || src.length;

  for (let i = start; i < end; i++) {
    let r = func(item(src, i), i, i, src);
    if (r === BREAK) return i;
  }

  return end;
}
/**
 * Type-agnostic forEach loop
 *
 * @param src
 * @param func
 * @returns {number|*}
 */


function forEach(src, func) {
  if (!T.isVal(src)) return -1;

  if (!T.isArr(src) || !T.isStr(src) || !T.isList(src)) {
    let i = 0;
    let keys = Object.keys(src);
    const len = keys.length;

    for (; i < len; i++) {
      // let r = ;
      const k = keys[i],
            v = src[k];
      if (func(v, k, i, src) === BREAK) return i;
    }

    return i;
  }

  const len = src.length;

  if (!T.isArr(src)) {
    for (let i = 0; i < len; i++) {
      const v = src[i];
      let r = func(v, i, i, src);
      if (r === BREAK) return i;
    }
  } else {
    for (let i = 0; i < len; i++) {
      const v = item(src, i);
      let r = func(v, i, i, src);
      if (r === BREAK) return i;
    }
  }

  return src.length;
}
/**
 * Type-agnostic forEachRight loop
 *
 * @param src
 * @param func
 * @param range
 * @returns {number|*}
 */


function forEachRight(src, func, range = []) {
  if (!T.isArr(src) || !T.isStr(src)) {
    let i = 0;
    let keys = Object.keys(src);

    for (let i = keys.length - 1; i >= 0; i--) {
      if (i < range[1]) continue;
      if (i >= range[0]) return i;
      let r = func(src[keys[i]], keys[i], i, src);
      if (r === BREAK) return i;
    }

    return i;
  }

  for (let i = src.length - 1; i >= 0; i--) {
    let r = func(item(src, i), i, i, src);
    if (r === BREAK) return i;
  }

  return src.length;
}
/**
 * Extended version of native indexOf method, using {@link forEach}
 * @see forEach
 * @param {Array|Object|String|NodeList|HTMLCollection} src
 * @param {Function|Object|Array} pred - predicate function/{key:value}/[keys]
 * @returns {number}
 */


function firstIndex(src, pred) {
  pred = predicate(pred, () => true);
  let r = -1;
  forEach(src, function (v, k, i) {
    r = pred(v, k, i, src);

    if (r === true) {
      r = i;
      return BREAK;
    }
  });
  return r;
}
/**
 * Extended version of native first method, using {@link firstIndex}
 * @see firstIndex
 * @param {Array|Object|String|NodeList|HTMLCollection} src
 * @param {Function|Object|Array} [pred] - predicate function/{key:value}/[keys]
 * @returns {*}
 */


function first(src, pred) {
  return item(src, firstIndex(src, pred));
}
/**
 * Returns true if first item matches predicate
 *
 * @param {Array|Object|String|NodeList|HTMLCollection} src
 * @param {Function|Object|Array} [pred] - predicate function/{key:value}/[keys] pred
 * @returns {boolean|*}
 */


function startsWith(src, pred) {
  if (T.isStr(src) && T.isStr(pred)) {
    return src.indexOf(pred) === 0;
  }

  pred = predicate(pred, () => true);
  return pred(first(src));
}
/**
 *
 * @param {Array|Object|String|NodeList|HTMLCollection} src
 * @param {Function|Array|Object} pred
 * @returns {number}
 */


function lastIndex(src, pred) {
  pred = predicate(pred, () => true);
  let r = -1;
  forEachRight(src, function (v, k, i) {
    r = pred(v, k, i);

    if (r === true) {
      r = i;
      return BREAK;
    }
  });
  return r;
}
/**
 *
 * @param {Array|Object|String|NodeList|HTMLCollection} src
 * @param {Function|Array|Object} [pred]
 * @returns {*}
 */


function last(src, pred) {
  return src[lastIndex(src, pred)];
}
/**
 *
 * @param {Array|Object|String|NodeList|HTMLCollection} src
 * @param {Function|Array|Object} pred
 * @returns {boolean|*}
 */


function endsWith(src, pred) {
  if (T.isStr(src) && T.isStr(pred)) {
    return src.indexOf(pred) === src.length - pred.length;
  }

  pred = predicate(pred, () => true);
  return pred(last(src));
}
/**
 * Reverse array-like src
 *
 * @param {Array|Object|String|NodeList|HTMLCollection} src
 * @returns {Array|Object|String|NodeList|HTMLCollection} - reversed src
 */


function reverse(src) {
  if (T.isArr(src)) return src.reverse();
  let rev = "";
  forEachRight(src, function (it) {
    rev += it;
  });
  return rev;
}
/**
 * A more versatile alternative to native "some" method
 *
 * @param {Array|Object|String|NodeList|HTMLCollection} src
 * @param {Function|Array|Object} pred
 * @returns {boolean}
 */


function any(src, pred) {
  // if (!func){
  //     if (T.isArr(src) || T.isStr(src)) return src.length>0;
  //     return Object.keys(src).length>0;
  // }
  let fn = predicate(pred);
  let r = false;
  forEach(src, function (v, k, i, src) {
    r = fn(v, k, i, src);
    if (r === true) return BREAK;
  });
  return r;
}
/**
 * A more versatile alternative to native "every" method
 *
 * @param {Array|Object|String|NodeList|HTMLCollection} src
 * @param {Function|Array|Object} pred
 * @returns {boolean}
 */


function all(src, pred) {
  pred = predicate(pred, () => true);
  let r = true;
  forEach(src, function (v, k, i, src) {
    r = pred(v, k, i, src);
    if (r === false) return BREAK;
  });
  return r;
}

function filterStr(src, pred, right = false, omit = false) {
  pred = predicate(pred, () => true);
  let res = "";
  let loop = right ? forEachRight : forEach;
  loop(src, function (v, k, i) {
    if (!pred || pred(v, k, i, src) === omit) res += v;
  });
  return res;
}

function filterObj(src, pred, right = false, omit = false) {
  if (T.isArr(pred)) {
    let a = Object.assign({}, pred);
    if (omit) pred = (v, k) => !any(a, k);else pred = (v, k) => any(a, k);
  } else pred = predicate(pred, () => true);

  let res = {}; // let loop = right ? ForEachRight : ForEach;

  const keys = Object.keys(src);
  const len = keys.length;

  if (!right) {
    for (let i = 0; i < len; i++) {
      const k = keys[i];
      const v = src[k];
      if (pred(v, k, i, src) !== omit) res[k] = v;
    }
  } else {
    for (let i = len - 1; i >= 0; i--) {
      const k = keys[i];
      const v = src[k];
      if (pred(v, k, i, src) !== omit) res[k] = v;
    }
  } // loop(src, function (v, k, i) {
  //     if (pred(v, k, i, src) !== omit) res[k] = v;
  // });


  return res;
}

function filterArr(src, pred, right = false, omit = false) {
  if (T.isArr(pred)) {
    let a = Object.assign([], pred);
    if (omit) pred = (v, k, i) => !any(a, i);else pred = (v, k, i) => any(a, i);
  } else pred = predicate(pred, () => true);

  let res = [];
  const len = src.length;

  if (!right) {
    for (let i = 0; i < len; i++) {
      const v = src[i];

      if (pred(v, i, i, src) !== omit) {
        res.push(v);
      }
    }
  } else {
    for (let i = len - 1; i >= 0; i--) {
      const v = src[i];

      if (!pred(v, i, i, src) !== omit) {
        res.push(v);
      }
    }
  }

  return res;
}
/**
 * A more versatile alternative to native "filter" method
 *
 * @param {Array|Object|String|NodeList|HTMLCollection} src - source
 * @param {Function|Array|Object} pred - predicate function/{key:value}/[keys]
 * @param {boolean} [right] - reverse loop
 * @returns {Array|Object|String}
 */


function filter(src, pred, right = false) {
  if (T.isStr(src)) return filterStr(src, pred, right);
  if (T.isArr(src) || T.isList(src)) return filterArr(src, pred, right);
  return filterObj(src, pred, right);
}
/**
 * Opposite of filter, returns items not matching predicate
 *
 * @param {Array|Object|String|NodeList|HTMLCollection} src - source
 * @param {Function|Array|Object} pred - predicate function/{key:value}/[keys]
 * @param {boolean} [right] - reverse loop
 * @returns {Array|Object|String}
 */


function omit(src, pred, right = false) {
  if (T.isStr(src)) return filterStr(src, pred, right, true);
  if (T.isArr(src) || T.isList(src)) return filterArr(src, pred, right, true);
  return filterObj(src, pred, right, true);
}
/**
 * {@link filter} in reverse order (right)
 *
 * @param {Array|Object|String|NodeList|HTMLCollection} src - source
 * @param {Function|Array|Object} pred - predicate function/{key:value}/[keys]
 * @returns {Array|Object|String}
 */


function filterRight(src, pred) {
  return filter(src, pred, true);
}
/**
 * Find max index
 *
 * @param {Array|Object|String|NodeList|HTMLCollection} list
 * @param {Function|String} pred - predicate function/key
 * @return {number}
 */


function maxIndex(list, pred) {
  pred = funOrKey(pred);
  let mx;
  let index = -1;
  forEach(list, function (i, ix) {
    let x = pred(i, ix);

    if (!mx) {
      mx = x;
      index = ix;
    } else if (x >= mx) {
      mx = x;
      index = ix;
    }
  });
  return index;
}
/**
 * Find max
 *
 * @param {Array|Object|String|NodeList|HTMLCollection} list
 * @param {Function|String} pred - predicate function/key
 * @return {number}
 */


function max(list, pred) {
  return list[maxIndex(list, pred)];
}
/**
 * Find min index
 *
 * @param {Array|Object|String|NodeList|HTMLCollection} list
 * @param {Function|String} pred - predicate function/key
 * @return {number}
 */


function minIndex(list, pred) {
  pred = funOrKey(pred);
  let mn;
  let index = -1;
  forEach(list, function (i, ix) {
    let x = pred(i, ix);

    if (!mn) {
      mn = x;
      index = ix;
    } else if (x <= mn) {
      mn = x;
      index = ix;
    }
  });
  return index;
}
/**
 * Find min
 *
 * @param {Array|Object|String|NodeList|HTMLCollection} list
 * @param {Function|String} pred - predicate function/key
 * @return {number}
 */


function min(list, pred) {
  return list[minIndex(list, pred)];
}

function mapArr(src, func, right = false) {
  let res = []; // let loop = right ? ForEachRight : ForEach;

  const len = src.length;

  if (!right) {
    for (let i = 0; i < len; i++) {
      let r = func(src[i], i, src);
      if (r === BREAK) break;
      if (!T.isUnd(r)) res.push(r);
    }
  } else {
    for (let i = len; i >= 0; i--) {
      let r = func(src[i], i, src);
      if (r === BREAK) break;
      if (!T.isUnd(r)) res.push(r);
    }
  } // loop(src, function (a, i) {
  //     let r = func(a, i, src);
  //     if (!T.isUnd(r))
  //         res.push(r);
  // });


  return res;
}

function mapObj(src, func, right = false) {
  let res = {}; // let loop = right ? ForEachRight : ForEach;

  const keys = Object.keys(src);
  const len = src.length;

  if (!right) {
    for (let i = 0; i < len; i++) {
      const k = keys[i];
      const v = src[k];
      let r = func(v, k, i, src);
      if (r === BREAK) break;
      if (!T.isUnd(r)) res[k] = r;
    }
  } else {
    for (let i = len; i >= 0; i--) {
      const k = keys[i];
      const v = src[k];
      let r = func(v, k, i, src);
      if (r === BREAK) break;
      if (!T.isUnd(r)) res[k] = r;
    }
  } // loop(src, function (v, k, i) {
  //     let r = func(v, k, i, src);
  //     if (!T.isUnd(r))
  //         res[k] = r
  // });


  return res;
}
/**
 * A more versatile alternative to native "map" method
 *
 * @param {Array|Object|String|NodeList|HTMLCollection} src - source
 * @param {Function|Array|Object} transform - transformer function
 * @param {boolean} [right] - reverse loop
 * @returns {Array|Object|String}
 */


function map(src, transform, right = false) {
  transform = predicate(transform, v => v);
  if (T.isArr(src)) return mapArr(src, transform, right);else if (T.isObj(src)) return mapObj(src, transform, right);
}
/**
 * A more versatile alternative to native "flatMap" method, flattens first level items
 *
 * @param {Array|Object|String|NodeList|HTMLCollection} src - source
 * @param {Function|Array|Object} [transform] - transformer function
 * @returns {Array|Object|String}
 */


function flatMap(src, transform) {
  let res;
  if (T.isStr(src)) res = "";else if (T.isArr(src)) res = [];else res = {};
  forEach(src, function (a, i) {
    let f;

    if (!!transform) {
      f = transform(a, i, src);
    } else {
      if (!T.isArr(res) && T.isObj(res)) {
        f = {};
        f[i] = a;
      } else {
        f = a;
      }
    }

    res = concat(res, f);
  });
  return res;
}
/**
 * A more versatile alternative to native "reduce" method
 *
 * @param {any} src - source
 * @param {Function|Array|Object} func - reducer function
 * @param {any} [acc] - accumulator
 * @returns {any}
 */


function reduce(src, func, acc = src) {
  if (T.isUnd(func)) {
    func = (rs, v) => rs + v;
  }

  forEach(src, (v, k, src) => {
    acc = func(acc, v, k, src);
  });
  return acc;
}
/**
 * {@link reduce} in reverse
 * @see reduce
 * @param {any} src - source
 * @param {Function|Array|Object} func - reducer function
 * @param {any} [acc] - accumulator
 * @returns {any}
 */


function reduceRight(src, func, acc = src) {
  forEachRight(src, (v, k, src) => {
    acc = func(acc, v, k, src);
  });
}
/**
 * Randomly shuffle array's items
 * @param {ArrayLike} arrayLike
 */


function shuffle(arrayLike) {
  return Array.prototype.sort.call(arrayLike, () => Math.random() - 0.5);
}
/**
 * Sort array ascending with optional field parameter
 * @param {ArrayLike} arrayLike
 * @param {Function} [fieldFn]
 * @param {String} [locale]
 */


function sortAsc(arrayLike, fieldFn, locale = 'en') {
  let compare = fieldFn ? function (a, b) {
    return ('' + fieldFn(a)).localeCompare('' + fieldFn(b), locale);
  } : undefined;
  return Array.prototype.sort.call(arrayLike, compare);
}
/**
 * Sort array descending with optional field parameter
 * @param {ArrayLike} arrayLike
 * @param {Function} [fieldFn]
 * @param {String} [locale]
 */


function sortDesc(arrayLike, fieldFn, locale = 'en') {
  let compare = fieldFn ? function (a, b) {
    return ('' + fieldFn(b)).localeCompare('' + fieldFn(a), locale);
  } : undefined;
  return Array.prototype.sort.call(arrayLike, compare);
}
/**
 * Extract single key-value pairs from object
 *
 * @param object
 * @return {Object[]}
 */


function keyValuePairs(object) {
  let entries = [];
  forEach(object, (v, k) => {
    entries.push(T.dict(k, v));
  });
  return entries;
}
/**
 * Like Object.entries extracts key-value pairs as [[key1,value1],[key2,value2],...]
 *
 * @param {Object} object
 * @return {Array[]}
 */


function entries(object) {
  let entries = [];
  forEach(object, (v, k) => {
    entries.push([k, v]);
  });
  return entries;
}
/**
 * Translate(rename) object fields using dict parameter, omitting undefined keys
 * @param {Object} source
 * @param {Object|Array} dict
 * @return {Array|Object|String}
 */


function translateObject(source, dict) {
  if (T.isArr(dict)) {
    filter(source, dict);
  }

  const keys = Object.keys(dict);
  let res = filter(source, keys);

  for (let key of keys) {
    res[dict[key]] = res[key];
    delete res[key];
  }

  return res;
}
/**
 * Recursive deep merge {@param target} with {@param source}
 *
 * @param {Object|Array} target
 * @param {Object|Array} source
 * @param {Array} excludeKeys - keys to be skipped while merging
 * @param maxDepth - maximum recursive depth
 * @param allowUnsafeProps - allow unsafe properties like __proto__
 * @return {Object|Array}
 */


function deepMerge(target, source, {
  excludeKeys = [],
  maxDepth = 999,
  allowUnsafeProps = false
} = {
  excludeKeys: [],
  maxDepth: 999,
  allowUnsafeProps: false
}, depth = 0) {
  if (depth >= maxDepth) return target;
  forEach(source, (v, k) => {
    if (excludeKeys && contains(excludeKeys, k)) return;
    if (allowUnsafeProps && contains(UNSAFE_PROPS, k)) return;

    if (T.isObj(source[k])) {
      target[k] = deepMerge(emptyOf(source[k]), source[k], {
        excludeKeys,
        maxDepth,
        depth: depth + 1
      });
    } else target[k] = v;
  });
  return target;
}
/**
 * Recursive deep clone {@param source}
 * @see deepMerge
 *
 * @param {Object|Array} source
 * @param {Array} excludeKeys - keys to be skipped while merging
 * @param {Number} [maxDepth] - maximum recursive depth
 * @param {boolean} [allowUnsafeProps] - allow unsafe properties like __proto__
 * @return {Object|Array}
 */


function deepClone(source, {
  excludeKeys = [],
  maxDepth = 999,
  allowUnsafeProps = false
} = {
  excludeKeys: [],
  maxDepth: 999,
  allowUnsafeProps: false
}) {
  return deepMerge(emptyOf(source), source, {
    excludeKeys,
    maxDepth,
    allowUnsafeProps
  });
}

function _keyGen(key, fnName) {
  let keyGen = key;

  if (T.isStr(key)) {
    keyGen = item => item[key];
  } else if (T.isArr(key)) {
    keyGen = item => reduce(item, (res, v, k) => {
      if (contains(key, k)) {
        return res + v;
      }
    }, "");
  } else if (!T.isFun(key)) {
    throw Error(`${fnName} key only accepts: String, [String,...], Function`);
  }

  return keyGen;
}
/**
 * Join arrays of objects based on a generated or static key
 *
 * @param {Function|String} key
 * @param {Object[]} lists
 * @return {Object}
 */


function join(key, ...lists) {
  if (lists.length === 0) return [];
  if (!all(lists, T.isArr)) throw Error("Join only accepts arrays of data!");

  let keyGen = _keyGen(key, "Join");

  const joined = {};
  forEach(lists, list => {
    forEach(list, item => {
      const joinKey = keyGen(item);
      const presentValue = joined[joinKey];

      if (!presentValue) {
        joined[joinKey] = item;
      } else {
        joined[joinKey] = concat(presentValue, item);
      }
    });
  });
  return joined;
}
/**
 * Group arrays based on generated or static key(s)
 *
 * @param {Function|String} key
 * @param {Object[]} lists
 * @return {Object}
 */


function groupBy(key, ...lists) {
  if (lists.length === 0) return {};
  if (!all(lists, T.isArr)) throw Error("GroupBy only accepts arrays of data!");

  let keyGen = _keyGen(key, "GroupBy");

  const group = {};
  forEach(lists, list => {
    forEach(list, item => {
      const joinKey = keyGen(item);
      const presentValue = group[joinKey];

      if (!presentValue) {
        group[joinKey] = [item];
      } else {
        group[joinKey] = concat(presentValue, item);
      }
    });
  });
  return group;
} // noinspection JSUnusedGlobalSymbols


module.exports = {
  ANY,
  ALL,
  BREAK,
  item,
  contains,
  add,
  remove,
  toggle,
  concat,
  emptyOf,
  objMatchOne,
  objMatchAll,
  deepMerge,
  deepClone,
  forN,
  forEachRange,
  forEach,
  forEachRight,
  firstIndex,
  first,
  startsWith,
  lastIndex,
  last,
  endsWith,
  reverse,
  any,
  all,
  filter,
  filterRight,
  reduce,
  reduceRight,
  map,
  flatMap,
  keyValuePairs,
  entries,
  maxIndex,
  max,
  minIndex,
  min,
  shuffle,
  sortAsc,
  sortDesc,
  translateObject,
  omit,
  join,
  groupBy,
  objectValues
};
},{"./types":"6rRoH"}],"6rRoH":[function(require,module,exports) {
/**
 * @module core/types
 * @memberOf core
 */

/**
 * If is class or function return class/function name else returns typeof
 * @param x
 * @return {"undefined"|"object"|"boolean"|"number"|"string"|"function"|"symbol"|"bigint"|*}
 */
function typeName(x) {
  if (x.hasOwnProperty('constructor')) {
    return x.constructor.name;
  }

  return typeof x;
}
/** Is undefined
 * @param x
 * @returns {boolean}
 */


function isUnd(x) {
  return x !== null && x === undefined;
}
/** Is null
 * @param x
 * @return {boolean}
 */


function isNull(x) {
  return x === null;
}
/** Is value !null && !undefined
 * @param x
 * @return {boolean|boolean}
 */


function isVal(x) {
  return !isUnd(x) && !isNull(x);
}
/** Is number
 * @param x
 * @return {boolean}
 */


function isNum(x) {
  return typeof x === "number";
}
/** Is string|String
 * @param x
 * @return {boolean}
 */


function isStr(x) {
  return typeof x === "string" || x instanceof String;
}
/** Is function
 * @param x
 * @return {boolean}
 */


function isFun(x) {
  return typeof x === "function";
}
/** Is object
 * @param x
 * @return {boolean|boolean}
 */


function isObj(x) {
  return x !== null && typeof x === "object";
}
/** Is Array
 * @param x
 * @return {boolean}
 */


function isArr(x) {
  return x instanceof Array;
}
/** Is primitive isVal && !isObj && !isFun
 * @param x
 * @return {boolean}
 */


function isPrim(x) {
  return isVal(x) && !isObj(x) && !isFun(x) || typeof x === 'symbol';
}
/** Is List (has length property and item() function)
 * @param x
 * @return {boolean|boolean}
 */


function isList(x) {
  return isVal(x.length) && isFun(x.item);
}
/** Is MutableList (has length property, item() and add() functions)
 * @param x
 * @return {boolean}
 */


function isMutableList(x) {
  return isVal(x.length) && isFun(x.item) && isFun(x.add);
}
/** Is Set type
 * @param x
 * @return {boolean}
 */


function isSet(x) {
  return x instanceof Set;
}
/** Is Map type
 * @param x
 * @return {boolean}
 */


function isMap(x) {
  return x instanceof Map;
}
/** Is Error type
 * @param x
 * @return {boolean}
 */


function isError(x) {
  return x instanceof Error;
}
/** Is Element/Node
 * @param x
 * @return {boolean}
 */


function isEl(x) {
  return x instanceof Element || x instanceof HTMLElement || x instanceof Node;
}
/** Is NodeList || HTMLCollection
 * @param x
 * @return {boolean}
 */


function isEls(x) {
  return x instanceof HTMLCollection || x instanceof NodeList;
}
/**
 * Object has field
 * @param {Object} obj - source object
 * @param {String} field - field/property name
 * @param {Function} [pred] - optional predicate function to check field
 * @return {boolean}
 */


function hasField(obj, field, pred) {
  if (!isVal(obj)) return false;

  if (isFun(pred)) {
    return pred(obj[field]);
  }

  return obj.hasOwnProperty(field);
}
/** Is Empty Array/List/Object/String
 * @param x
 * @return {boolean}
 */


function isEmpty(x) {
  if (hasField(x, 'length')) return x.length <= 0;
  if (isFun(x)) return false;
  if (isObj(x)) return Object.keys(x).length <= 0;
  return true;
}
/**
 * Custom Enum implementation
 *
 * @param src {Object | String[]}
 * @return {Object}
 * @constructor
 */


function Enum(src) {
  let c = 0;
  let MAP = {};

  for (let i of Object.keys(src)) {
    MAP[MAP[c] = i] = c++;
  }

  return MAP;
}
/**
 * Deserialize sequence of key values (key, value, ...) into an object
 *
 * @param {any} args - key{String}, value{*} sequence
 * @return {Object}
 */


function dict(...args) {
  let o = {};

  for (let i = 0; i < args.length; i++) {
    if (i % 2 !== 0) continue;
    o[args[i]] = args[i + 1];
  }

  return o;
}

module.exports = {
  typeName,
  isUnd,
  isNull,
  isVal,
  isNum,
  isStr,
  isFun,
  isObj,
  isArr,
  isPrim,
  isList,
  isMutableList,
  isSet,
  isMap,
  isError,
  isEl,
  isEls,
  hasField,
  isEmpty,
  Enum,
  dict
};
},{}],"5nsjA":[function(require,module,exports) {
const TYPE = require("./type");

const {
  deepClone
} = require("../core/collections");

const {
  flatMap
} = require("../core/collections");

const {
  setElementProps,
  compileProps,
  normalize
} = require("./utils");
/**
 *
 * @param {String|null} tag
 * @param {Object|String} prop
 * @param {any[]} [children]
 * @constructor
 */


function VNode(tag = "#text", prop, children) {
  tag = tag.toLowerCase();
  this.tag = tag;
  this.element = undefined;

  if (tag === '#text') {
    this.$t = TYPE.TEXT;
    this.isText = true;
    this.text = prop;
    Object.defineProperty(this, '$clone', {
      value: function () {
        return createText(this.text);
      },
      configurable: false,
      writable: false,
      enumerable: false
    });
    return;
  }

  this.$t = TYPE.NODE;
  this.isNode = true;
  let cp = compileProps(prop || {});
  this.attrs = cp.attrs;
  this.events = cp.events;
  this.props = cp.props;
  this.children = normalize(children || [], {
    createText,
    parent: this
  });

  this.isEmpty = () => this.children.length === 0;

  Object.defineProperty(this, '$clone', {
    value: function () {
      return new VNode(this.tag, deepClone(this.props || {}), (children || []).map(c => c.$clone()));
    }
  });
}

Object.defineProperty(VNode.prototype, '$parent', {
  value: undefined,
  configurable: false,
  writable: true,
  enumerable: false
});
Object.defineProperty(VNode.prototype, 'isEmpty', {
  get() {
    return this.children.length === 0;
  }

});

VNode.prototype.$destroy = function () {
  this.element.remove();
};

function createNode(tag, props, children) {
  return new VNode(tag, props, children);
}

function createText(text) {
  return new VNode("#text", text);
}

module.exports = {
  VNode,
  TYPE,
  createNode,
  createText
};
},{"./type":"31kdc","../core/collections":"ZJYAj","./utils":"4gsj0"}],"4gsj0":[function(require,module,exports) {
const JSS = require("./jss");

const {
  setEvent
} = require("../dom/event");

const {
  forEach
} = require("../core/collections");

const {
  isPrim,
  isArr,
  isStr,
  isVal
} = require("../core/types");

function randomId() {
  return Date.now().toString(24).slice(2) + Math.random().toString(24).slice(6);
}

function normalize(children, {
  createText,
  parent,
  empty = [],
  list
}) {
  if (!(children instanceof Array)) {
    if (children === null || children === undefined) return empty;else children = [children];
  }

  let norm = [];
  const len = children.length;

  for (let i = 0; i < len; i++) {
    let child = children[i];

    if (child === null || child === undefined || isPrim(child)) {
      if (typeof child === 'symbol') child = child.toString();
      child = createText("" + child);
      child.$parent = parent;
      norm.push(child);
      continue;
    } // fragment


    if (child.isNode && child.tag === null) {
      child = child.children || [];
    }

    if (child instanceof Array) {
      child = normalize(child, {
        createText,
        parent
      });

      for (let j = 0; j < child.length; j++) {
        child[j].$parent = parent;
        norm.push(child[j]);
      } // norm.push(list(child))


      continue;
    }

    child.$parent = parent;
    norm.push(child);
  }

  if (norm.length === 0) norm = empty;
  return norm;
}

function isEventPropKey(key) {
  return /on[A-Z]+/.test(key);
}

function normalizeEventName(eventName) {
  return eventName.slice(2).toLowerCase();
}

function compileProps(props) {
  const cats = {
    events: {},
    attrs: {}
  };
  forEach(props, (v, k) => {
    if (isEventPropKey(k)) cats.events[normalizeEventName(k)] = v;else cats.attrs[k] = v;
  });
  return cats;
}

function compileStyles(styles, joinWith) {
  if (!isVal(styles)) return '';else if (isStr(styles)) return styles;else if (isArr(styles)) return styles.join(joinWith);
  return JSS.generateCss(styles, joinWith);
}

function setElementProps(element, attrs, events, view) {
  if (attrs) {
    forEach(attrs, (val, key) => {
      if (key === 'style') {
        val = compileStyles(val, ' ');
      } else if (key === 'className') {
        key = 'class';
      }

      element.setAttribute(key, val);
    });
  }

  if (events) {
    forEach(events, (v, k) => {
      if (view) v = v.bind(view);
      setEvent(element, k, v);
    });
  }
}

function randomHexColor() {
  return '#' + Math.random().toString(16).slice(2, 8);
}

function sameProps(currentProps = {}, newProps = {}) {
  const curKeys = Object.keys(currentProps);
  const newKeys = Object.keys(newProps);
  if (curKeys.length !== newKeys.length) return false;

  for (let curKey of curKeys) {
    if (newProps[curKey] !== currentProps[curKey]) return false;
  }

  return true;
}

module.exports = {
  randomId,
  normalize,
  setElementProps,
  compileProps,
  compileStyles,
  sameProps,
  randomHexColor
};
},{"./jss":"35ZMu","../dom/event":"2aVtu","../core/collections":"ZJYAj","../core/types":"6rRoH"}],"35ZMu":[function(require,module,exports) {
const {
  kebab
} = require("../core/cases");

const {
  forEach
} = require("../core/collections");

function generateStyles(jss) {
  let styles = [];
  forEach(jss, (val, prop) => {
    styles.push(`${kebab(prop)}: ${val};`);
  });
  return styles;
}

function generateCss(jss, joinWith = '\n') {
  return generateStyles(jss).sort((a, b) => a[0].localeCompare(b[0])).join(joinWith);
}

module.exports = {
  generateStyles,
  generateCss
};
},{"../core/cases":"5vnm4","../core/collections":"ZJYAj"}],"5vnm4":[function(require,module,exports) {
/**
 * @module
 * @memberOf core
 */

/**
 * @static
 * @param name
 * @returns {string}
 */
function kebab(name) {
  let kb = "";
  let pres = false;

  for (let i = 0; i < name.length; i++) {
    let c = name.charAt(i);

    if (c === '_') {
      kb += '-';
      pres = true;
      continue;
    }

    if (c >= 'A' && c <= 'Z') {
      if (i > 0 && !pres) {
        kb += '-';
      }
    }

    kb += c.toLowerCase();
    pres = false;
  }

  return kb;
}
/**
 * @static
 * @param name
 * @returns {string}
 */


function snake(name) {
  let snk = "";
  let pres = false;

  for (let i = 0; i < name.length; i++) {
    let c = name.charAt(i);

    if (c === '-') {
      snk += '_';
      pres = true;
      continue;
    }

    if (c >= 'A' && c <= 'Z') {
      if (i > 0 && !pres) {
        snk += '_';
      }
    }

    snk += c.toLowerCase();
    pres = false;
  }

  return snk;
}
/**
 * @static
 * @param name
 * @returns {string}
 */


function camel(name) {
  let cml = "";
  let pres = false;

  for (let i = 0; i < name.length; i++) {
    let c = name.charAt(i);

    if (c === '-' || c === '_') {
      pres = true;
    } else if (pres === true) {
      cml += c.toUpperCase();
      pres = false;
    } else {
      if (i === 0) {
        cml += c.toLowerCase();
      } else {
        cml += c;
      }
    }
  }

  return cml;
}
/**
 * @static
 * @param name
 * @returns {string}
 */


function pascal(name) {
  let psc = "";
  let pres = false;

  for (let i = 0; i < name.length; i++) {
    let c = name.charAt(i);

    if (c === '-' || c === '_') {
      pres = true;
    } else if (pres === true) {
      psc += c.toUpperCase();
      pres = false;
    } else {
      if (i === 0) {
        psc += c.toUpperCase();
      } else {
        psc += c;
      }
    }
  }

  return psc;
}

module.exports = {
  kebab,
  camel,
  pascal,
  snake
};
},{}],"2aVtu":[function(require,module,exports) {
/**
 * @module DOM
 * @memberOf dom
 */
const scope = require("../core/scope");

const {
  isArr,
  hasField,
  isEmpty
} = require("../core/types");

const {
  contains,
  forEach,
  filter
} = require("../core/collections");

const {
  error
} = require("../core/logging");

const {
  funcBodyEquals
} = require("../core/functions");
/**
 * Set listener for event type(s) on element, removes identical event listeners to avoid duplication
 *
 * @param {HTMLElement|Element|Node} target - target element
 * @param {String|Array} event - event type(s)
 * @param {Function} listener
 * @param {AddEventListenerOptions?} [options]
 */


function setEvent(target, event, listener, options) {
  if (!scope.isBrowser()) {
    error("Events are browser only!");
    return;
  }

  if (!isArr(event)) {
    if (contains(event, ' ')) {
      event = event.split(' ').Map(it => it.trim());
    } else event = [event];
  }

  target.__EVENTS__ = target.__EVENTS__ || {};
  forEach(event, ev => {
    target.__EVENTS__[ev] = target.__EVENTS__[ev] || [];

    let f = function (e) {
      listener(e, target);
    };

    if (!hasField(options, 'duplicates', a => a)) {
      target.__EVENTS__[ev] = filter(target.__EVENTS__[ev], fl => {
        if (funcBodyEquals(fl.l, listener)) {
          target.removeEventListener(ev, fl.f, fl.o);
          return false;
        } // else {
        //     console.log('notEqual',fl.l.toString(), listener.toString())
        // }

      });
    }

    target.__EVENTS__[ev].push({
      f: f,
      l: listener,
      o: options
    });

    target.addEventListener(ev, f, options);
  });
}
/**
 * Clear all event listeners of type from element
 *
 * @param {HTMLElement|Element|Node} target - target element
 * @param {String|Array} event - event type(s)
 */


function clearEvent(target, event) {
  if (!scope.isBrowser()) {
    error("Events are browser only!");
    return;
  }

  if (!isArr(event)) {
    if (contains(event, ' ')) {
      event = event.split(' ').Map(it => it.trim());
    } else event = [event];
  }

  target.__EVENTS__ = target.__EVENTS__ || {};
  if (isEmpty(target.__EVENTS__)) return;
  forEach(event, function (ev) {
    target.__EVENTS__[ev] = target.__EVENTS__[ev] || [];
    if (isEmpty(target.__EVENTS__[ev])) return;
    forEach(target.__EVENTS__[ev], fl => {
      target.removeEventListener(ev, fl.f, fl.o);
      return false;
    });
    target.__EVENTS__[ev] = [];
  });
}
/**
 * Target has event listener for event type
 *
 * @param {HTMLElement|Element|Node} target - target element
 * @param {String} type - event type
 * @return {boolean}
 */


function hasEvent(target, type) {
  return target.__EVENTS__ && target.__EVENTS__[type] && !isEmpty(target.__EVENTS__[type]);
}

module.exports = {
  setEvent,
  clearEvent,
  hasEvent
};
},{"../core/scope":"65tBD","../core/types":"6rRoH","../core/collections":"ZJYAj","../core/logging":"2wPER","../core/functions":"1xAXG"}],"1xAXG":[function(require,module,exports) {
/**
 * @module
 * @memberOf core
 */
function bodyOf(func) {
  let match = func.toString().match(/{[\w\W]*}/);
  return match === null ? func.toString() : match[0];
}
/**
 * Check if function bodies are equal
 * @param {Function} f1
 * @param {Function} f2
 * @return {boolean}
 */


function funcBodyEquals(f1, f2) {
  return bodyOf(f1) === bodyOf(f2);
}
/**
 * Throttle function execution.
 * {@link https://css-tricks.com/debouncing-throttling-explained-examples/}
 *
 * @param {Function} func - function
 * @param {Number} intervalMs
 * @return {Function} - throttled function
 */


function throttle(func, intervalMs) {
  var ___last___ = new Date().getTime();

  function throttled(args) {
    if (new Date().getTime() - ___last___ >= intervalMs) {
      ___last___ = new Date().getTime();
      func.call(this, args);
    }
  }

  return throttled;
}
/**
 * Debounce function execution.
 * {@link https://css-tricks.com/debouncing-throttling-explained-examples/}
 *
 * @param {Function} func - function
 * @param {Number} afterMs - milliseconds after last call
 * @return {Function} - debounced function
 */


function debounce(func, afterMs) {
  var ___timeout___ = null;

  function debounced(...args) {
    clearTimeout(___timeout___);
    ___timeout___ = setTimeout(function (_this) {
      return func.apply(_this, args);
    }, afterMs, this);
  }

  debounced.flush = function (...args) {
    clearTimeout(___timeout___);
    return func.apply(this, args);
  };

  return debounced;
}
/**
 * Bind args to function and return a no-arg function
 * @param {Function} func - source function
 * @param {any[]} args - array of arguments to bind
 * @return {Function}
 */


function bindArgs(func, args) {
  return function () {
    return func.apply(this, args);
  };
}

function once(func) {
  var called = false;
  return function () {
    if (!called) {
      called = true;
      return func.apply(this, arguments);
    }
  };
}

module.exports = {
  funcBodyEquals,
  throttle,
  debounce,
  bindArgs,
  once
};
},{}],"h7hOa":[function(require,module,exports) {
const {
  clearEvent,
  setEvent
} = require("../dom/event");

const {
  forEach
} = require("../core/collections");

const {
  compileStyles
} = require("./utils");

function patchAttrs(newAttrs, oldAttrs, element) {
  const newKeys = Object.keys(newAttrs);
  const currentKeys = Object.keys(oldAttrs);
  const keys = Object.keys(newAttrs); // const len = keys.length
  // console.log(newAttrs, oldAttrs)

  for (let key of keys) {
    const newVal = newAttrs[key]; // if (currentKeys.indexOf(key) < 0) {
    //     element.setAttribute(key, newVal)
    // } else {

    const curVal = oldAttrs[key];

    if (key === 'style') {
      const newStyle = compileStyles(newVal, ' ');
      const currentStyle = compileStyles(curVal, ' ');

      if (newStyle !== currentStyle) {
        //     console.log()
        element.setAttribute('style', newStyle);
      }
    } else if (key === 'className') {
      element.setAttribute('class', newVal);
    } else {
      element.setAttribute(key, newVal);
    } // }

  }

  for (let key of currentKeys) {
    if (newKeys.indexOf(key) < 0) {
      element.removeAttribute(key);
    }
  }
}

function patchEvents(newEvents = {}, oldEvents = {}, element) {
  forEach(oldEvents, function (listener, event) {
    if (newEvents[event] !== listener) {
      clearEvent(element, event);
    }
  });
  forEach(newEvents, function (listener, event) {
    // console.log(event, listener)
    setEvent(element, event, listener);
  });
}

module.exports = {
  patchAttrs,
  patchEvents
};
},{"../dom/event":"2aVtu","../core/collections":"ZJYAj","./utils":"4gsj0"}],"6vQOL":[function(require,module,exports) {
const {
  normalize
} = require("./utils");

const {
  renderView
} = require("./view");

const {
  createNode,
  createText
} = require("./vnode");

function h(type, prop, ...children) {
  if (type === null) {
    return children || [];
  }

  if (prop === null || prop === undefined) {
    prop = {};
  }

  if (type.$isView) {
    // return renderView(type.$clone(), prop, children);
    return type.$clone().$updateWith(prop, children);
  }

  return createNode(type, prop, normalize(children, {
    createText
  }));
}

function t(text) {
  return createText(text);
}

module.exports = {
  h,
  t
};
},{"./utils":"4gsj0","./view":"7zuzL","./vnode":"5nsjA"}],"2gqzN":[function(require,module,exports) {
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _ui = require("../../ui");

var _h = require("../../ui/h");

var _TodoList = _interopRequireDefault(require("./views/TodoList"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// import Exir from "exir/ui";
// import {BasicRouter, Route} from "exir/ui/router/basic";
var _default = _ui.Exir.createComponent({
  name: 'App',

  render() {
    return _ui.Exir.jsx("div", {
      style: {
        margin: 'auto',
        textAlign: 'center'
      }
    }, _ui.Exir.jsx("div", {
      className: "flex items-center justify-center"
    }, _ui.Exir.jsx("div", {
      className: "w-full flex items-center justify-center bg-teal-lightest font-sans"
    }, _ui.Exir.jsx("div", {
      className: "bg-white rounded shadow p-6 m-4 w-full lg:w-3/4 lg:max-w-lg"
    }, _ui.Exir.jsx("h1", {
      className: "text-xl font-bold"
    }, "Todo List"), _ui.Exir.jsx(_TodoList.default, null)))));
  }

});

exports.default = _default;
},{"../../ui":"2Wqnn","../../ui/h":"6vQOL","./views/TodoList":"5X6bV"}],"5X6bV":[function(require,module,exports) {
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _ui = require("../../../ui");

var _logging = require("../../../core/logging");

var _TodoItem = _interopRequireDefault(require("./TodoItem"));

var _httpclient = _interopRequireDefault(require("../httpclient"));

var _utils = require("../../../ui/utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = _ui.Exir.createComponent({
  name: 'TodoList',
  state: {
    text: "ABC",
    items: []
  },

  beforeCreate() {
    // info('Created TodoList', this.$instanceId)
    this.$store.subscribe(this.onStoreUpdate); // this.setState(s=>{

    this.state.items = this.$store.getState().items; // });
  },

  // async Updated() {
  //     // cancel currently pending requests
  //     // httpclient.cancel("todolist")
  //     // // send request
  //     // let response = await httpclient.get('get', {
  //     //     params: { name: 'exir' },
  //     //     cancelToken: "todolist"
  //     // }).then((ajax) => ajax.rs).catch(()=>null)
  //     // console.log(response)
  //
  // },
  onStoreUpdate(storeState) {
    // console.warn(storeState.items)
    // console.log(this.$ref('item0'))
    // console.log(this.$ref('item2'))
    this.setState(state => {
      state.items = [...storeState.items];
    });
  },

  removeItem(key) {
    console.log(key);
    this.setState(state => {
      state.items.splice(state.items.findIndex(si => si.key === key), 1);
    }); // this.
  },

  render() {
    return _ui.Exir.jsx(null, null, _ui.Exir.jsx("div", {
      className: "flex my-4"
    }, _ui.Exir.jsx("input", {
      value: this.state.text,
      type: "text",
      onChange: (_, el) => this.state.text = el.value,
      className: "shadow appearance-none border rounded w-full py-2 px-3 mr-4 text-grey-darker",
      placeholder: "Add Todo"
    }), _ui.Exir.jsx("button", {
      className: "flex-no-shrink p-2 border-2 rounded text-teal border-teal hover:bg-teal",
      onClick: () => {
        let len = this.$store.getState().items.length;

        for (let i = 0; i < 500; i++) {
          this.$store.dispatch({
            name: 'additem',
            payload: {
              key: len + i,
              text: this.state.text + (len + i)
            }
          });
        }
      }
    }, "Add"), _ui.Exir.jsx("hr", null), _ui.Exir.jsx("div", null, this.state.items.length)), _ui.Exir.jsx("div", {
      id: 'list'
    }, this.state.items.map(it => _ui.Exir.jsx(_TodoItem.default, {
      remove: this.removeItem.bind(this),
      key: it.key,
      text: it.text
    }))), _ui.Exir.jsx("hr", null));
  } // shouldUpdate() {
  //     return true;
  // }


});

exports.default = _default;
},{"../../../ui":"2Wqnn","../../../core/logging":"2wPER","./TodoItem":"2sOXA","../httpclient":"VDrmo","../../../ui/utils":"4gsj0"}],"2sOXA":[function(require,module,exports) {
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _ui = require("../../../ui");

var _logging = require("../../../core/logging");

var _utils = require("../../../ui/utils");

var _default = _ui.Exir.createComponent({
  name: 'TodoItem',
  props: {
    text: ""
  },
  state: {
    done: false
  },

  render({
    props,
    state
  }) {
    // console.log(state, props);
    return _ui.Exir.jsx("div", {
      className: "block text-center mb-4",
      style: {
        color: this.state.color,
        borderRadius: '20px',
        border: '2px solid ' + this.state.color,
        padding: '10px 20px',
        userSelect: 'none'
      },
      onClick: () => {
        this.setState(() => {
          state.done = !state.done; // setTimeout(()=>this.rem(), 1)
          // this.rem();
        });
        this.rem(); // state.done = (!state.done);
      }
    }, state.done ? _ui.Exir.jsx("s", {
      style: "display: inline-block; min-width: 150px"
    }, props.text, "-", props.key) : _ui.Exir.jsx("b", {
      style: "display: inline-block; min-width: 150px"
    }, props.text, "-", props.key));
  },

  rem() {
    // this.props.remove(this.$key);
    this.$store.dispatch({
      name: 'removeitem',
      payload: {
        key: this.props.key
      }
    }); // this.$update()
  },

  beforeCreate() {
    this.state.color = (0, _utils.randomHexColor)();
  },

  Created() {// console.log(this.$name, this.$instanceId)
  },

  beforeUpdate(props) {// info('Todo', props.text, 'beforeUpdate', this.state.done)
    // this.$store.dispatch({name: 'inc'})
  },

  Updated() {// info('Todo', this.props.text, 'Updated', this.state.done)
  },

  Destroyed(props) {
    (0, _logging.info)(`Destroyed item with ${props}`);
  }

});

exports.default = _default;
},{"../../../ui":"2Wqnn","../../../core/logging":"2wPER","../../../ui/utils":"4gsj0"}],"VDrmo":[function(require,module,exports) {
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _client = require("../../http/client");

var _default = new _client.XHttpClient('http://httpbin.org', {
  ratePerMinute: 20
});

exports.default = _default;
},{"../../http/client":"GeZFj"}],"GeZFj":[function(require,module,exports) {
/**
 * Asynchronous Http Client using XHR
 * @module http/client
 * @memberOf http
 */
const http = require('./methods');

const {
  error
} = require("../core/logging");

const {
  Ajax
} = require("./ajax");

const {
  startsWith,
  endsWith,
  filter,
  forEach
} = require('../core/collections');

class InterceptorStore {
  constructor() {
    this.all = [];
    this.any = false;
  }

  use(interceptor) {
    this.all.push(interceptor);
    this.any = true;
  }

  async intercept(ajax) {
    for (let i = 0; i < this.all.length; i++) {
      ajax = await this.all[i](ajax);
    }

    return ajax;
  }

}
/**
 * Async Http Client using XHR
 * @class
 */


class XHttpClient {
  /**
   *
   * @param {String} host - Server host address
   * @param {Number} [ratePerMinute] - Maximum requests allowed per minute (default 300)
   * @param {Object} [defaultParams] - Default params set on every request
   * @param {Object} [defaultHeaders] - Default headers set on every request
   * @param {Number} [timeout=3000]
   * @param {Number} [retries]
   */
  constructor(host = '', {
    ratePerMinute = 300,
    defaultParams,
    defaultHeaders,
    timeout,
    retries
  } = {}) {
    if (endsWith(host, '/')) {
      host = host.split('').splice(host.length - 1).join();
    }
    /**
     * Interceptors
     * @type {{request: InterceptorStore, response: InterceptorStore}}
     */


    this.interceptors = {
      request: new InterceptorStore(),
      response: new InterceptorStore()
    };
    this.host = host;
    this.__queue = [];
    this.__sending = [];
    this.__interval = undefined;
    this.__ratePerMinute = ratePerMinute;
    this.__timeBetween = 60000 / ratePerMinute;
    this.__lastRequestTime = new Date().getTime() - this.__timeBetween;
    this.timeout = timeout || 60000;
    this.retries = retries || 0;
    this.defaultHeaders = defaultHeaders || {};
    this.defaultParams = defaultParams || {};
  }
  /**
   *
   * @param client
   * @private
   */


  _intervalSend(client) {
    if (client.__queue.length === 0) {
      clearInterval(client.__interval);
      client.__interval = undefined;
      return;
    }

    let now = new Date().getTime();

    if (now - client.__lastRequestTime > client.__timeBetween) {
      let ajax = client.__queue.shift();

      client._sendImmediately(ajax, now);
    }
  }

  _sendImmediately(ajax, now) {
    if (this.interceptors.request.any) {
      this.interceptors.request.intercept(ajax).then(() => {
        ajax.send();

        this.__sending.push(ajax);

        this.__lastRequestTime = now;
      }).catch(e => {
        console.error(e);
      });
    } else {
      ajax.send();

      this.__sending.push(ajax);

      this.__lastRequestTime = now;
    }
  }

  _removeSendingRequest(request) {
    let rqi = this.__sending.indexOf(request);

    if (rqi >= 0) {
      this.__sending.splice(rqi);
    }
  }
  /**
   *
   * @param ajax
   * @param responseType
   * @param cancelToken
   * @return {Promise<Ajax>}
   * @private
   */


  _addRequest(ajax, {
    responseType,
    cancelToken
  }) {
    this.__queue.push(ajax);

    if (!this.__interval) {
      this.__interval = setInterval(this._intervalSend, 1, this);
    }

    ajax.cancelToken = cancelToken;
    if (responseType) ajax.xhr.responseType = responseType;
    ajax.RETRIES = 0;
    ajax.xhr.timeout = this.timeout;

    if (this.defaultHeaders) {
      ajax.headers(this.defaultHeaders);
    }

    if (this.defaultParams) {
      forEach(this.defaultParams, (val, key) => {
        ajax.rq.setArg(key, val);
      });
    }

    let promise = http.makePromise(ajax, {
      default(ajax, res, rej, client) {
        client._removeSendingRequest(ajax);
      },

      onSuccess(ajax, res, rej, client) {
        if (client.interceptors.response.any) {
          client.interceptors.response.intercept(ajax).then(() => res(ajax)).catch(e => rej(e));
        } else res(ajax);
      },

      onFail(ajax, res, rej, client) {
        if (client.interceptors.response.any) {
          client.interceptors.response.intercept(ajax).then(() => rej(ajax)).catch((ajax, err) => rej(ajax, err));
        } else rej(ajax);

        return rej(ajax, Error('Request failed.'));
      },

      onTimeout(ajax, res, rej, client) {
        if (ajax.RETRIES >= client.retries) {
          return rej(ajax, Error('Request timed out after ' + ajax.RETRIES + ' retries.'));
        }

        client.__sending.push(ajax.resend());

        ajax.RETRIES += 1;
      }

    }, this);
    ajax._promise_ = promise;
    return promise;
  }
  /**
   * Add ajax request to queue
   * @param {Ajax} ajax
   */


  send(ajax) {
    return this._addRequest(ajax);
  }
  /**
   *
   * @param method
   * @param route
   * @param params
   * @param headers
   * @param content
   * @param responseType
   * @param cancelToken
   * @return {Promise<Ajax>}
   * @private
   */


  _contentRequest(method, route, {
    params,
    headers,
    content,
    responseType,
    cancelToken
  }) {
    if (!startsWith(route, '/') && route.length > 1) {
      route = '/' + route;
    }

    return this._addRequest(method(this.host + route, params || {}).headers(headers || {}).withContent(content || {
      type: '',
      data: ''
    }), {
      responseType,
      cancelToken
    });
  }
  /**
   * Enqueue http GET request
   *
   * @param {String} route - request route - appends to host address
   * @param {Object} [params] - request params(args)
   * @param {Object} [headers] - request headers
   * @param {String} [responseType] - "text"|"json"|"xml"|"document"|"arraybuffer"|"blob"|"ms-stream"|""
   * @param {String} [cancelToken] - A token used to cancel a group of requests
   * @return {Promise<Ajax>}
   */


  get(route, {
    params,
    headers,
    responseType,
    cancelToken
  } = {}) {
    if (!startsWith(route, '/') && route.length > 1) {
      route = '/' + route;
    }

    return this._addRequest(http.Get(this.host + route, params).headers(headers), {
      responseType,
      cancelToken
    });
  }
  /**
   * Enqueue http POST request
   *
   * @param {String} route - request route - appends to host address
   * @param {Object} [params] - request params(args)
   * @param {Object} [headers] - request headers
   * @param {http.HttpContent|Object} [content] - request content. example: {type:'json', data={count: 13}}
   * @param {String} [responseType] - "text"|"json"|"xml"|"document"|"arraybuffer"|"blob"|"ms-stream"|""
   * @param {String} [cancelToken] - A token used to cancel a group of requests
   * @return {Promise<Ajax>}
   */


  post(route, {
    params,
    headers,
    content,
    responseType,
    cancelToken
  } = {}) {
    return this._contentRequest(http.Post, route, {
      params,
      headers,
      content,
      responseType,
      cancelToken
    });
  }
  /**
   * Enqueue http PUT request
   *
   * @param {String} route - request route - appends to host address
   * @param {Object} [params] - request params(args)
   * @param {Object} [headers] - request headers
   * @param {http.HttpContent} [content] - request content. example: {type:'json', data={count: 13}}
   * @param {String} [responseType] - "text"|"json"|"xml"|"document"|"arraybuffer"|"blob"|"ms-stream"|""
   * @param {String} [cancelToken] - A token used to cancel a group of requests
   * @return {Promise<Ajax>}
   */


  put(route, {
    params,
    headers,
    content,
    responseType,
    cancelToken
  } = {}) {
    return this._contentRequest(http.Put, route, {
      params,
      headers,
      content,
      responseType,
      cancelToken
    });
  }
  /**
   * Enqueue http PATCH request
   *
   * @param {String} route - request route - appends to host address
   * @param {Object} [params] - request params(args)
   * @param {Object} [headers] - request headers
   * @param {http.HttpContent} [content] - request content. example: {type:'json', data={count: 13}}
   * @param {String} [responseType] - "text"|"json"|"xml"|"document"|"arraybuffer"|"blob"|"ms-stream"|""
   * @param {String} [cancelToken] - A token used to cancel a group of requests
   * @return {Promise<Ajax>}
   */


  patch(route, {
    params,
    headers,
    content,
    responseType,
    cancelToken
  } = {}) {
    return this._contentRequest(http.Patch, route, {
      params,
      headers,
      content,
      responseType,
      cancelToken
    });
  }
  /**
   * Enqueue http DELETE request
   *
   * @param {String} route - request route - appends to host address
   * @param {Object} [params] - request params(args)
   * @param {Object} [headers] - request headers
   * @param {http.HttpContent} [content] - request content. example: {type:'json', data={count: 13}}
   * @param {String} [responseType] - "text"|"json"|"xml"|"document"|"arraybuffer"|"blob"|"ms-stream"|""
   * @param {String} [cancelToken] - A token used to cancel a group of requests
   * @return {Promise<Ajax>}
   */


  delete(route, {
    params,
    headers,
    content,
    responseType,
    cancelToken
  } = {}) {
    return this._contentRequest(http.Delete, route, {
      params,
      headers,
      content,
      responseType,
      cancelToken
    });
  }
  /**
   * Cancel all requests(sending or enqueued) with given token
   * @param {String} token
   */


  cancel(token) {
    this.__queue = filter(this.__queue, a => a.cancelToken !== token);
    let sending = filter(this.__sending, a => a.cancelToken === token);
    forEach(sending, ajax => {
      try {
        ajax.xhr.abort();
      } catch (e) {
        console.error(e);
      }
    });
    this.__sending = filter(this.__sending, a => a.cancelToken !== token);
  }

  cancelAll() {
    if (this.__interval >= 0) clearInterval(this.__interval);
    setTimeout(() => {
      forEach(this.__sending, function (a) {
        try {
          a.xhr.abort();
        } catch (e) {}
      });
      this.__queue = [];
    }, 1);
  }

}

module.exports = {
  XHttpClient
};
},{"./methods":"18oj9","../core/logging":"2wPER","./ajax":"1Dg39","../core/collections":"ZJYAj"}],"18oj9":[function(require,module,exports) {
/**
 * @fileOverview
 *
 * @module http/methods
 * @memberOf http
 */
const {
  Ajax
} = require("./ajax");

const {
  HttpContent
} = require("./request");
/**
 * A factory for {@link http.Ajax}
 * @private
 * @param {HttpMethod} method - {@link HttpMethod}
 * @param {String} url
 * @param {Object} params
 * @param {Object} headers
 * @param {HttpContent} content
 * @param {Object} callbacks - {success:Function?, fail: Function?, progress: Function?, prepare: Function?,uploadProgress: Function?, uploadFinish: Function?}
 * @return {http.Ajax}
 */


function makeHttpRequest(method, url, params, headers, content, callbacks) {
  let ajax = new Ajax(method.toUpperCase(), url, params, headers);

  if (content && content.type) {
    if (content.type.toLowerCase() === 'json') {
      ajax.jsonData(content.data);
    } else if (content.type.toLowerCase() === 'urlencoded') {
      ajax.urlEncodedData(content.data);
    } else if (content.type.toLowerCase() === 'form') {
      ajax.formData(content.data);
    } else {
      ajax.Rq.setContent(content.type, content.data);
    }
  }

  callbacks.success && ajax.onSuccess(callbacks.success);
  callbacks.fail && ajax.onFail(callbacks.fail);
  callbacks.progress && ajax.onProgress(callbacks.progress);
  callbacks.prepare && (ajax.preparedCallback = callbacks.prepare);
  callbacks.uploadProgress && (ajax.uploadProgressCallback = callbacks.uploadProgress);
  callbacks.uploadFinish && (ajax.uploadFinishCallback = callbacks.uploadFinish);
  return ajax;
} //{method, url, args, headers, type, data, success, fail, progress, prepare, uploadProgress, uploadFinish}

/**
 * A factory for {@link http.Ajax}. creates Ajax request with supplied {@link HttpRequestOptions}
 *
 * @param {HttpRequestOptions} opts
 * @return {http.Ajax}
 */


function makeRequest(opts) {
  return makeHttpRequest(opts.method || 'OPTIONS', opts.url, opts.params, opts.headers, new HttpContent(opts.type, opts.data), {
    success: opts.success,
    fail: opts.fail,
    progress: opts.progress,
    prepare: opts.prepare,
    uploadProgress: opts.uploadProgress,
    uploadFinish: opts.uploadFinish
  });
}
/**
 * @private
 * @param {Ajax} ajax - Ajax request
 * @param {Object} callbacks - ajax event listeners
 * @param {any} extra - passed to callbacks
 * @returns {Promise<Ajax>}
 */


function makePromise(ajax, callbacks = {}, extra = {}) {
  return new Promise((resolve, reject) => {
    ajax.onSuccess(async () => {
      if (callbacks.default) {
        callbacks.default(ajax, resolve, reject, extra);
      }

      let callback = callbacks.onSuccess;
      if (callback) try {
        callback(ajax, resolve, reject, extra);
      } catch (e) {} else resolve(ajax);
    });
    ajax.onFail(async () => {
      if (callbacks.default) {
        callbacks.default(ajax, resolve, reject, extra);
      }

      let callback = callbacks.onFail;
      if (callback) try {
        callback(ajax, resolve, reject, extra);
      } catch (e) {} else reject(ajax);
    });
    ajax.onAbort(async () => {
      if (callbacks.default) {
        callbacks.default(ajax, resolve, reject, extra);
      }

      let callback = callbacks.onAbort;
      if (callback) try {
        callback(ajax, resolve, reject, extra);
      } catch (e) {} else reject(ajax);
    });
    ajax.onTimeout(async () => {
      if (callbacks.default) {
        callbacks.default(ajax, resolve, reject, extra);
      }

      let callback = callbacks.onTimeout;
      if (callback) try {
        callback(ajax, resolve, reject, extra);
      } catch (e) {} else reject(ajax);
    });
  });
}
/**
 * Send request asynchronously
 *
 * @param {HttpRequestOptions} opts
 * @return {Promise<any>}
 */


async function sendRequest(opts) {
  let r = makeRequest(opts);
  r.send(opts.finish);
  return await makePromise(r);
}
/**
 * Create Ajax GET request
 *
 * @param {String} url - server url
 * @param {Object} [params] - query string params
 * @returns {http.Ajax}
 */


function Get(url, params) {
  return new Ajax('GET', url, params);
}
/**
 * Create Ajax POST request
 *
 * @param {String} url - server url
 * @param {Object} [params] - query string params
 */


function Post(url, params) {
  return new Ajax('POST', url, params);
}
/**
 * Create Ajax DELETE request
 *
 * @param {String} url - server url
 * @param {Object} [params] - query string params
 * @returns {http.Ajax}
 */


function Delete(url, params) {
  return new Ajax('DELETE', url, params);
}
/**
 * Create Ajax PUT request
 *
 * @param {String} url - server url
 * @param {Object} [params] - query string params
 * @returns {Ajax}
 */


function Put(url, params) {
  return new Ajax('PUT', url, params);
}
/**
 * Create Ajax PATCH request
 *
 * @param {String} url - server url
 * @param {Object} [params] - query string params
 * @returns {http.Ajax}
 */


function Patch(url, params) {
  return new Ajax('PATCH', url, params);
}
/**
 * Create and send GET request
 *
 * @param {HttpRequestOptions} opt
 * @return {Promise<http.Ajax>}
 */


function sendGet(opt) {
  opt.method = 'GET';
  opt.type = undefined;
  opt.data = undefined;
  return sendRequest(opt);
}
/**
 * Create and send DELETE request
 *
 * @param {HttpRequestOptions} opt
 * @return {Promise<http.Ajax>}
 */


function sendDelete(opt) {
  opt.method = 'DELETE';
  return sendRequest(opt);
}
/**
 * Create and send POST request
 *
 * @param {HttpRequestOptions} opt
 * @return {Promise<http.Ajax>}
 */


function sendPost(opt) {
  opt.method = 'POST';
  return sendRequest(opt);
}
/**
 * Create and send PUT request
 *
 * @param {HttpRequestOptions} opt
 * @return {Promise<http.Ajax>}
 */


function sendPut(opt) {
  opt.method = 'PUT';
  return sendRequest(opt);
}
/**
 * Create and send PATCH request
 *
 * @param {HttpRequestOptions} opt
 * @return {Promise<http.Ajax>}
 */


function sendPatch(opt) {
  opt.method = 'PATCH';
  return sendRequest(opt);
}

module.exports = {
  makeHttpRequest,
  makeRequest,
  makePromise,
  sendRequest,
  Get,
  Post,
  Delete,
  Put,
  Patch,
  sendGet,
  sendDelete,
  sendPost,
  sendPut,
  sendPatch
};
},{"./ajax":"1Dg39","./request":"1PSrW"}],"1Dg39":[function(require,module,exports) {
/**
 * Wrapper class for XHR
 * @module http/ajax
 * @memberOf http
 */
const {
  HttpRq,
  HttpContent
} = require("./request");

const {
  HttpRs
} = require("./response");

const T = require("../core/types");

const {
  error
} = require("../core/logging");

const {
  forEach,
  deepClone
} = require("../core/collections");
/**
 * A wrapper class for {@link XMLHttpRequest} to facilitate sending requests and handling events
 * @class
 * @property {Response} rs
 * @property {Request} rq
 */


class Ajax {
  /**
   * @constructor
   * @param {HttpMethod|HttpRq} m - Request method string or {@link http.HttpRq}
   * @param {String} [url]
   * @param {Object} [params] - Request parameters object
   * @param {Object?} [headers] - Headers object
   * @param {HttpContent?} [content] - Optional http content {@link HttpContent}
   */
  constructor(m, url, params = {}, headers = {}, content = new HttpContent()) {
    /** @type {HttpRq}
     * @see {http.HttpRq}
     */
    this.rq = {};
    /** @type {http.HttpRs}
     * @see {http.HttpRs}
     */

    this.rs = {};

    if (m instanceof HttpRq) {
      this.rq = m;
    } else {
      this.rq = new HttpRq(m, url, params, headers, content);
    } // Fields


    this.rs = {
      readyState: 0
    };
    this.xhr = new XMLHttpRequest();

    this.preparedCallback = function (ajax) {};

    this.progressCallback = function (ajax, event) {};

    this.uploadProgressCallback = function (ajax, event) {};

    this.successCallback = function (ajax) {};

    this.uploadFinishCallback = function (ajax) {};

    this.failCallback = function (ajax, error) {};

    this.timeoutCallback = function (ajax) {};

    this.abortCallback = function (ajax) {};

    Object.defineProperty(this, 'xhr', {
      enumerable: false
    });
  } // Methods

  /**
   * Set header
   * @param {String} n - header name
   * @param {String} [v] - header value
   * @returns {Ajax}
   */


  header(n, v) {
    this.rq.setHeader(n, v);
    return this;
  }

  /**
   * Add/Set headers
   * @param {Object} hdrs - headers object
   * @returns {Ajax}
   */
  headers(hdrs = {}) {
    forEach(hdrs, (v, k) => {
      this.rq.setHeader(k, v);
    });
    return this;
  }

  /**
   * @param {Function} callback
   * @returns {Ajax}
   */
  onSuccess(callback) {
    this.successCallback = callback;
    return this;
  }

  /**
   * @param {Function} callback
   * @returns {Ajax}
   */
  onUploadSuccess(callback) {
    this.uploadFinishCallback = callback;
    return this;
  }

  /**
   * @param {Function} callback
   * @returns {Ajax}
   */
  onFail(callback) {
    this.failCallback = callback;
    return this;
  }

  onTimeout(callback) {
    this.timeoutCallback = callback;
    return this;
  }

  onAbort(callback) {
    this.abortCallback = callback;
    return this;
  }
  /**
   * @param {Function} callback
   * @returns {Ajax}
   */


  onProgress(callback) {
    this.progressCallback = callback;
    return this;
  }

  /**
   * @param {Function} callback
   * @returns {Ajax}
   */
  onUploadProgress(callback) {
    this.uploadProgressCallback = callback;
    return this;
  }

  /**
   * Set custom content {@link HttpContent}
   * @param {HttpContent} content
   * @returns {Ajax}
   */
  withContent(content = {}) {
    switch (content.type) {
      case 'json':
        this.rq.jsonContent(content.data);
        break;

      case 'xml':
        this.rq.xmlContent(content.data);
        break;

      case 'form':
        this.rq.formContent(content.data);
        break;

      case 'form_multipart':
        this.rq.formMultiPartContent(content.data);
        break;

      case 'form_urlencoded':
        this.rq.formUrlEncodedContent(content.data);
        break;

      default:
        this.rq.setContent(content.type, content.data);
    }

    return this;
  }
  /**
   * Set xml request data
   * @param {XMLDocument} data
   * @returns {Ajax}
   */


  xmlData(data) {
    this.rq.xmlContent(data);
    return this;
  }
  /**
   * Set form-data request data
   * @param {String|Node} form
   * @returns {Ajax}
   */


  formData(form) {
    this.rq.formContent(form);
    return this;
  }

  /**
   * Set json request data
   * @param {String|Object} data
   * @returns {Ajax}
   */
  jsonData(data) {
    this.rq.jsonContent(data);
    return this;
  }

  /**
   * Set url-encoded request data
   * @param {Object} data - simple data object
   * @returns {Ajax}
   */
  urlEncodedData(data) {
    this.rq.formUrlEncodedContent(data);
    return this;
  }

  prepare(reset) {
    if (this.isPrepared && !reset) {
      // self.onprepare && self.onprepare(self.rq);
      return this;
    } // prepare url


    let url = this.rq.url;

    if (this.rq.args && !T.isEmpty(this.rq.args)) {
      url.indexOf('?') >= 0 || (url += '?');
      url += this.rq.buildUrlEncoded();
    }

    this.rs = {
      readyState: 0
    };
    reset && (this.xhr = new XMLHttpRequest());
    this.xhr.open(this.rq.method, url); // prepare headers

    forEach(this.rq.headers, (val, key) => {
      try {
        this.xhr.setRequestHeader(key, this.rq.headers[val]);
      } catch (e) {
        error('Error while setting default header \n>>(', key, ')<< Non-standard header name.');
      }
    });
    let ajax = this;
    let xhr = this.xhr;

    this.xhr.onreadystatechange = function (ev) {
      // onloadend
      if (xhr.readyState === 4 && xhr.status !== 0) {
        let callback = ajax.failCallback;

        if (xhr.status >= 200 && xhr.status <= 399) {
          callback = ajax.successCallback;
        }

        ajax.rs = new HttpRs(xhr);
        callback && callback(ajax);
      }
    };

    this.xhr.onerror = function (ev) {
      ajax.failCallback && ajax.failCallback(ajax, ev);
    };

    this.xhr.onprogress = function (ev) {
      ajax.progressCallback && ajax.progressCallback(ajax, ev);
    };

    this.xhr.upload.onprogress = function (ev) {
      ajax.uploadProgressCallback && ajax.uploadProgressCallback(ajax, ev);
    };

    this.xhr.upload.onloadend = function (ev) {
      ajax.uploadFinishCallback && ajax.uploadFinishCallback(ajax, ev);
    };

    this.xhr.ontimeout = function (ev) {
      ajax.timeoutCallback && ajax.timeoutCallback(ajax, ev);
    };

    this.xhr.onabort = function (ev) {
      ajax.abortCallback && ajax.abortCallback(ajax, ev);
    };

    this.isPrepared = true;
    this.preparedCallback && this.preparedCallback(this.rq); // preparedCallback && preparedCallback();

    return this;
  }

  /**
   * Send XHR request
   * @returns {Ajax}
   */
  send() {
    this.prepare();

    try {
      this.xhr.send(this.rq.content.data);
    } catch (e) {
      this.failCallback(this, e);
    }

    return this;
  }

  resend() {
    return this.prepare(true).send();
  }
  /**
   * Send request with Promise
   * @return {Promise<Ajax>}
   */


  async sendAsync() {
    const ajax = this;
    const promise = new Promise((res, rej) => {
      ajax.onSuccess(() => {
        return res(ajax);
      });
      ajax.onFail(() => {
        rej(ajax);
      });
    });
    ajax.send();
    return promise;
  }

}

module.exports = {
  Ajax: Ajax
};
},{"./request":"1PSrW","./response":"5erTv","../core/types":"6rRoH","../core/logging":"2wPER","../core/collections":"ZJYAj"}],"1PSrW":[function(require,module,exports) {
const T = require("../core/types");

const {
  $,
  $$
} = require("../dom/query");
/**
 * Http Content class
 */


class HttpContent {
  constructor(type, data) {
    /**
     * @type {String}
     */
    this.type = type;
    /**
     * @type {String|Object|Element}
     */

    this.data = data;
  }

}
/**
 * Http request class
 * @class
 */


class HttpRq {
  /**
   * @param {HttpMethod} m
   */
  setMethod(m) {
    this.method = m.toUpperCase();
  }

  /**
   * @param {String} u
   */
  setUrl(u) {
    this.url = encodeURI(u);
  }

  /**
   * Set request param/arg
   * @param {String} n - name
   * @param {String} v - value
   */
  setArg(n, v) {
    this.args[n] = v;
  }

  buildUrlEncoded(args) {
    let ue = "";
    args = args || this.args;
    let argNames = Object.keys(args);

    if (argNames.length > 0) {
      for (let i = 0; i < argNames.length; i++) {
        ue += encodeURIComponent(argNames[i]) + '=' + encodeURIComponent(args[argNames[i]]);

        if (i < argNames.length - 1) {
          ue += '&';
        }
      }
    }

    return ue;
  }

  /**
   * Set request header
   * @param {String} n - name
   * @param {String} v - value
   */
  setHeader(n, v) {
    this.headers[n] = v.toString();
  }

  /**
   * Get request header
   * @param {String} n - name
   */
  getHeader(n) {
    return this.headers[n];
  }

  /**
   * Set request content
   * @param {String} contentType
   * @param {any} data
   */
  setContent(contentType, data) {
    this.content.type = contentType.toLowerCase();
    this.content.data = data;
  }

  /**
   * Set request json content
   * @param {String|Object} data
   */
  jsonContent(data) {
    let str = "";

    if (typeof data === "string") {
      str = data;
    } else {
      str = JSON.stringify(data);
    }

    this.setContent('json', str);
    this.setHeader('Content-Type', 'application/json');
  }

  /**
   * Set request xml content
   * @param {String|Node} data
   */
  xmlContent(data) {
    if (T.isStr(data)) this.setContent('xml', data);else this.setContent('xml', data.outerHTML);
    this.setHeader('Content-Type', 'application/xml');
  }

  /**
   * Set request multipart data from Form element
   * @param {String|Node|Element} form - form element/id
   */
  formContent(form) {
    let formElement = $$(form)[0];
    let frm = new FormData(formElement);
    this.formMultiPartContent(frm);
  }

  /**
   * Set request multipart data from FormData object
   * @param {FormData} frm - custom form data object
   */
  formMultiPartContent(frm) {
    this.setContent('form_multipart', frm); // this.setHeader('Content-Type', 'multipart/form-data; boundary=' + frm.boundary)
  }

  /**
   * Set request data as urlencoded
   * @param {Object} data
   */
  formUrlEncodedContent(data) {
    this.setContent('form_urlencoded', this.buildUrlEncoded(data));
    this.setHeader('Content-Type', 'application/x-www-form-urlencoded');
  }

  /**
   *
   * @param {HttpMethod} method
   * @param {String} url
   * @param {Object} args
   * @param {Object} headers
   * @param {HttpContent} content
   */
  constructor(method = 'GET', url, args, headers, content) {
    this.args = args || {};
    this.headers = headers || {};
    this.content = content || new HttpContent('#urlencoded', {});
    this.setMethod(method);
    this.setUrl(url);
  }

}

module.exports = {
  HttpContent,
  HttpRq
};
},{"../core/types":"6rRoH","../dom/query":"5AkM0"}],"5AkM0":[function(require,module,exports) {
/**
 * @module DOM
 * @memberOf dom
 */
const {
  isEl,
  isEls,
  isStr,
  isVal
} = require("../core/types");

const L = require("../core/logging");

const {
  cls
} = require("../dom/classes"); //
// import {isEl, isEls, isStr, isVal} from "../core/types";
// import {error} from "../core/logging";
// import {cls} from "../dom/classes";
//

/**
 * jQuery-like select "all" by query accepts element, nodes or query
 * @param {String|HTMLElement|Element|Node|HTMLCollection|NodeList} q - query string
 * @param {HTMLElement|Element|Node} [root] - root which query is issued from
 * @return {Array}
 */


function $(q, root = document) {
  if (isEl(q)) return Array.of(q);
  if (isEls(q)) return Array.from(q);

  if (!isStr(q)) {
    L.error(`Query is not string nor element X.$(${q})`);
    return null;
  }

  if (!isEl(root)) {
    L.error(`Query root is not a node!\t[X.$(${q}, ${root})]`);
    return null;
  }

  return Array.from(root.querySelectorAll(q));
}
/**
 * jQuery-like select "one" by query accepts element, node or query
 * @param {String|HTMLElement|Element|Node} q - query string
 * @param {HTMLElement|Element|Node} [root] - root which query is issued from
 * @return {Array} - returns array of length=1
 */


function $$(q, root = document) {
  if (isEl(q)) return Array.of(q);

  if (!isStr(q)) {
    L.error(`Query is not string nor element X.$$(${q})`);
    return null;
  }

  if (!isEl(root)) {
    L.error(`Query root is not a node!\t[X.$(${q}, ${root})]`);
    return null;
  }

  return Array.of(root.querySelector(q));
}
/**
 * Generate relative query of given element/node
 * @param {HTMLElement|Element|Node} e - element/node
 * @param {HTMLElement|Element|Node} maxParent - parent where the query relates to
 * @return {String} - query relative to maxParent
 */


function queryOf(e, maxParent, q) {
  if (!isVal(e) || !isEl(e)) {
    L.error(`\nQuery generator's first parameter must be Element/Node! CAUSE: X.queryOf(${e}, ${maxParent})`);
    return null;
  }

  maxParent = maxParent || document.body;
  let gen = e.tagName;
  q = q || "";

  if (e.id) {
    gen += e.id ? '#' + e.id : "";
    return gen + (!(q === "") ? ' ' + q : "");
  }

  cls(e).items.forEach(function (value) {
    gen = gen + (value !== '' ? '.' + value : '');
  });

  if (gen) {
    let sibs = $(gen, e.parentElement);

    if (sibs.length > 1) {
      let idx = Array.from(e.parentElement.children).findIndex(function (i) {
        return e === i;
      });

      if (idx > 0) {
        gen = gen + ":nth-child(" + (idx + 1) + ")";
      }
    }
  }

  if (e.parentElement && e.parentElement !== maxParent && e.parentElement !== document) {
    return queryOf(e.parentElement, maxParent) + " > " + gen + (!(q === "") ? ' ' + q : "");
  } else {
    return gen + (!(q === "") ? ' ' + q : "");
  }
}

module.exports = {
  $,
  $$,
  queryOf
};
},{"../core/types":"6rRoH","../core/logging":"2wPER","../dom/classes":"56l4I"}],"56l4I":[function(require,module,exports) {
/**
 * @module DOM
 * @memberOf dom
 */
const T = require("../core/types");

const {
  toggle,
  any,
  all,
  contains,
  filter,
  flatMap,
  forEach
} = require("../core/collections");
/**
 * Element classes CRUD wrapper
 * @memberOf dom
 */


class Classes {
  /**
   * Split element `className`
   * @param className
   * @return {String[]}
   */
  static split(className) {
    return className.trim().replace(/\s+/, ' ').split(' ');
  }
  /**
   * @param {HTMLElement|Element|Node} e - element
   */


  constructor(e) {
    this.element = e;
    Object.defineProperty(this, 'items', {
      get() {
        return this.classes;
      },

      set(v) {
        let upd = false;
        if (this.classes) upd = true;
        if (!T.isVal(v) || T.isEmpty(v)) this.classes = [];else if (T.isArr(v)) this.classes = v;else if (T.isStr(v)) this.classes = Classes.split(v);else if (v instanceof DOMTokenList) this.classes = Array.from(v);
        if (upd) this.__update__();
      }

    });
    this.items = e.getAttribute('class');
  }
  /**
   * Equivalent of `new Classes(e)`
   * @param e
   * @return {dom.Classes}
   */


  static of(e) {
    return new Classes(e);
  }

  __update__() {
    this.element.setAttribute('class', this.classes.join(' '));
  }
  /**
   * Element has class(es)
   * @param {String} c - class(es)
   * @return {boolean}
   */


  contains(...c) {
    c = flatMap(c);
    return all(c, it => contains(this.classes, it));
  }
  /**
   * Add class(es)
   * @param {String} c - class(es)
   */


  add(...c) {
    c = flatMap(c);
    forEach(c, it => {
      if (!this.contains(it)) {
        this.classes.push(it.toString());
      }
    });

    this.__update__();
  }
  /**
   * Remove class(es)
   * @param {String} c - class(es)
   * @return {boolean}
   */


  remove(...c) {
    c = flatMap(c);
    let l = this.classes.length;
    this.classes = filter(this.classes, it => {
      return !any(c, ci => ci.endsWith('*') ? it.startsWith(ci.replace('*', '')) : it === ci);
    });

    this.__update__();

    return l !== this.classes.length;
  }
  /**
   * Toggle class(es) - if exists toggle else adds
   * @param {String} c - class(es)
   */


  toggle(...c) {
    toggle(this.classes, c);

    this.__update__();
  }

}

Object.seal(Classes);
/**
 * Equivalent of `[new Classes(e)]{@link dom.Classes}`
 * @param e
 * @return {dom.Classes}
 */

function cls(e) {
  return Classes.of(e);
}
/**
 * Add class(es) [cls(e).add()]{@link dom.Classes#add}
 * @param {HTMLElement|Element|Node} e - element
 * @param c
 */


function addClass(e, ...c) {
  Classes.of(e).add(c);
}
/**
 * Remove class(es) [cls(e).remove()]{@link dom.Classes#remove}
 * @param {HTMLElement|Element|Node} e - element
 * @param c
 */


function removeClass(e, ...c) {
  Classes.of(e).remove(c);
}
/**
 * Has class(es) [cls(e).contains()]{@link dom.Classes#contains}
 * @param {HTMLElement|Element|Node} e - element
 * @param c
 */


function hasClass(e, ...c) {
  Classes.of(e).contains(c);
}
/**
 * Toggle classes [cls(e).toggle()]{@link dom.Classes#toggle}
 * @param {HTMLElement|Element|Node} e - element
 * @param c
 */


function toggleClass(e, ...c) {
  Classes.of(e).toggle(c);
}

module.exports = {
  Classes,
  cls,
  addClass,
  hasClass,
  removeClass,
  toggleClass
};
},{"../core/types":"6rRoH","../core/collections":"ZJYAj"}],"5erTv":[function(require,module,exports) {
/**
 * Http Response class
 * @property json {Object}
 * @property xml {XMLDocument}
 *
 */
class HttpRs {
  /**
   * @constructor
   * @param {XMLHttpRequest} xhr
   */
  constructor(xhr) {
    this.xhr = xhr;
    this.status = {
      code: xhr.status,
      text: xhr.statusText
    };
    this.headers = xhr.getAllResponseHeaders();
    this.contentLength = xhr.response.length || 0;
    this.data = xhr.response;
    this.json = undefined;
    this.xml = undefined;
    if (xhr.responseType === 'text' || xhr.responseType === '') this.text = xhr.responseText;
    Object.defineProperty(this, 'json', {
      get() {
        try {
          if (!xhr.responseJSON) {
            xhr.responseJSON = JSON.parse(this.xhr.responseText);
          }
        } catch (e) {
          console.log(e);
        }

        return xhr.responseJSON;
      }

    });
    Object.defineProperty(this, 'xml', {
      get() {
        try {
          if (!xhr.responseXML && !xhr.responseXml) {
            let parser = new DOMParser();
            xhr.responseXml = parser.parseFromString(self.text, "text/xml");
          }
        } catch (e) {
          console.log(e);
        }

        return xhr.responseXml;
      }

    });
  }

}

module.exports = {
  HttpRs
};
},{}],"4Bos7":[function() {},{}],"305r2":[function(require,module,exports) {
"use strict";

var _store = require("../../ui/store.js");

var _utils = require("../../ui/utils");

// import {randomId} from "../../ui/utils";
(0, _store.createGlobalStore)(function (state = {
  count: 0,
  items: [{
    key: 0,
    text: "Implement full featured client side routing"
  }, {
    key: 1,
    text: "Implement a REAL store (not redux) "
  }, {
    key: 2,
    text: "Create a working app template"
  }, {
    key: 3,
    text: "Make some showcases"
  }]
}, action) {
  switch (action.name) {
    case 'inc':
      return { ...state,
        count: state.count + 1
      };

    case 'dec':
      return { ...state,
        count: state.count - 1
      };

    case 'additem':
      {
        return { ...state,
          items: [...state.items, action.payload]
        };
      }

    case 'removeitem':
      {
        // let items = state.items.reverse().map(it=>({key: it.key+1, text: it.text}));
        let items = state.items.reverse(); // let idx = state.items.findIndex((it)=>it.key === action.payload.key );
        // if (idx>=0) items.splice(idx, 1);

        return { ...state,
          items: items
        };
      }

    default:
      return state;
  }
});
},{"../../ui/store.js":"1pv72","../../ui/utils":"4gsj0"}],"1pv72":[function(require,module,exports) {
const {
  debounce
} = require("../core/functions");

const {
  isVal
} = require("../core/types");

const {
  View
} = require("./view");

function Store(reducer) {
  var state = reducer(undefined, {});
  var listeners = [];
  if (!isVal(state)) throw TypeError('Store: Initial state is null or undefined,' + ' reducer does not return properly on random/empty state');

  this.subscribe = function (callback) {
    listeners.push(debounce(callback, 20));
  };

  this.unsubscribe = function (callback) {
    listeners.splice(listeners.indexOf(callback), 1);
  };

  this.getState = function () {
    return state;
  };

  this.dispatch = function (action) {
    state = reducer(state, action);
    listeners.forEach(callback => {
      callback(state, action); // setTimeout(callback, 1, state, action);
    });
  };
}

function createStore(reducer) {
  return new Store(reducer);
}

function createGlobalStore(reducer) {
  View.prototype.$store = createStore(reducer);
}

function setGlobalStore(store) {
  View.prototype.$store = store;
}

module.exports = {
  Store,
  createStore,
  createGlobalStore,
  setGlobalStore
};
},{"../core/functions":"1xAXG","../core/types":"6rRoH","./view":"7zuzL"}]},{},["4RFDN","4PwlW"], "4PwlW", "parcelRequire430d")

//# sourceMappingURL=index.c35b9498.js.map
